Search.setIndex({"docnames": ["coding_basics", "coding_in_cython", "coding_in_other", "coding_in_python", "doctesting", "git_advanced", "git_background", "git_basic", "git_setup", "github", "index", "packaging", "packaging_sage_library", "portability_testing", "review", "sage_manuals", "tools", "walkthrough", "workflows", "workspace"], "filenames": ["coding_basics.rst", "coding_in_cython.rst", "coding_in_other.rst", "coding_in_python.rst", "doctesting.rst", "git_advanced.rst", "git_background.rst", "git_basic.rst", "git_setup.rst", "github.rst", "index.rst", "packaging.rst", "packaging_sage_library.rst", "portability_testing.rst", "review.rst", "sage_manuals.rst", "tools.rst", "walkthrough.rst", "workflows.rst", "workspace.rst"], "titles": ["General Conventions", "Coding in Cython", "Using External Libraries and Interfaces", "Coding in Python for Sage", "Running Sage\u2019s Doctests", "Advanced Git", "Git Tips and References", "Git Basics", "Setting Up Git", "The Sage Repository on GitHub", "Welcome to Sage Developer Guide", "Packaging Third-Party Code for Sage", "Packaging the Sage Library for Distribution", "Testing on Multiple Platforms", "Reviewing Code", "The Sage Manuals", "Additional Development and Testing Tools", "Development Walk-through", "Using Git with GitHub", "Setting up your workspace"], "terms": {"There": [0, 1, 2, 4, 6, 7, 9, 11, 12, 13, 14], "ar": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 13, 14, 15, 16, 17, 18, 19], "mani": [0, 3, 5, 6, 9, 10, 11, 12, 13, 14, 16, 17], "wai": [0, 1, 2, 3, 4, 6, 7, 9, 10, 11, 12, 13, 14, 16], "contribut": [0, 5, 9, 10, 13, 19], "includ": [0, 2, 3, 4, 5, 7, 11, 12, 13, 14, 16, 17, 18], "share": [0, 1, 2, 9, 10, 11, 13, 15, 18], "script": [0, 4, 10, 12, 13, 15, 16], "worksheet": [0, 1], "implement": [0, 2, 3, 6, 9, 10, 11, 12, 13, 14], "new": [0, 3, 4, 5, 7, 9, 10, 12, 13, 14, 16, 17, 19], "us": [0, 1, 5, 6, 7, 8, 10, 12, 14, 15, 16, 17], "improv": [0, 7, 9, 14], "work": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 12, 13, 14, 15, 16, 17, 18, 19], "underli": [0, 4], "distribut": [0, 3, 7, 8, 10, 11, 14, 16], "1": [0, 1, 2, 3, 4, 5, 7, 8, 9, 11, 12, 13, 14, 16, 17, 18], "thi": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19], "guid": [0, 2, 6, 7, 9, 11, 13, 15, 17], "focus": [0, 2], "edit": [0, 2, 5, 6, 7, 10, 11, 13, 18, 19], "itself": 0, "i": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19], "just": [0, 2, 3, 4, 5, 7, 11, 12, 13, 14, 16, 17, 18], "gather": 0, "togeth": [0, 2, 3], "It": [0, 1, 2, 3, 4, 6, 7, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18], "provid": [0, 3, 4, 9, 11, 12, 13, 14, 16, 18], "clear": [0, 2, 14], "systemat": 0, "consist": [0, 2, 4, 5, 9, 11, 12, 13, 14], "access": [0, 2, 5, 9, 12, 13, 15], "larg": [0, 3, 11, 12, 16], "number": [0, 2, 3, 4, 5, 7, 9, 11, 12, 14, 16], "algorithm": [0, 2, 4, 11, 18], "coher": 0, "framework": [0, 3, 4, 13, 16], "make": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 16, 18], "sens": [0, 3, 11], "mathemat": [0, 3, 9, 10, 12, 14], "In": [0, 1, 2, 3, 4, 7, 9, 11, 12, 13, 15, 17, 19], "design": [0, 10, 12, 15], "semant": 0, "object": [0, 1, 2, 6, 7, 9, 12, 15, 17, 18], "definit": [0, 2, 3, 16], "etc": [0, 1, 3, 5, 9, 10, 11, 12, 13, 14], "inform": [0, 1, 2, 3, 4, 8, 9, 12, 13, 14, 15, 16], "how": [0, 2, 3, 5, 6, 7, 9, 10, 12, 13, 14, 16, 17, 18, 19], "correspond": [0, 2, 5, 7, 11, 13, 16], "everydai": 0, "see": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18], "http": [0, 1, 2, 3, 4, 5, 7, 9, 11, 13, 15, 16, 17, 18], "www": [0, 1, 2, 4, 15], "sagemath": [0, 2, 4, 5, 7, 9, 12, 13, 16, 17, 18], "org": [0, 1, 2, 3, 4, 11, 13, 15, 16], "link": [0, 1, 2, 10, 11, 12, 13, 14, 15], "compon": [0, 2, 3, 9, 11, 14, 16], "html": [0, 2, 3, 4, 9, 11, 13, 14, 15, 16], "full": [0, 13, 15, 16], "list": [0, 2, 3, 4, 11, 12, 13, 14, 17], "packag": [0, 1, 2, 4, 8, 9, 14, 16, 17], "ship": [0, 12, 14], "everi": [0, 2, 3, 5, 9, 10, 11, 12, 13, 19], "To": [0, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 15, 17, 18, 19], "meet": [0, 11], "goal": [0, 3, 14, 17], "easi": [0, 1, 2, 3, 5, 6, 7, 10, 13, 14, 17], "read": [0, 2, 4, 5, 6, 9, 10, 11, 13, 14, 17], "maintain": 0, "all": [0, 1, 2, 3, 5, 6, 7, 9, 10, 11, 12, 13, 14, 15, 16, 17, 19], "cython": [0, 2, 3, 4, 10, 12, 14, 17], "should": [0, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 16, 17, 18], "adher": [0, 9], "discuss": [0, 1, 2, 3, 4, 6, 9, 10, 11, 14, 18], "chapter": [0, 1, 2, 3, 4, 5, 6, 10, 17], "follow": [0, 1, 2, 3, 4, 7, 8, 9, 11, 12, 13, 14, 15, 16, 17, 19], "standard": [0, 1, 4, 9, 10, 12, 13, 14, 16], "format": [0, 6, 9, 11, 13, 14, 15], "rule": [0, 3, 6, 11, 14], "when": [0, 1, 2, 3, 4, 5, 6, 9, 10, 12, 13, 14, 16, 17, 18], "explain": [0, 2, 6, 9, 10, 11, 13, 14, 16, 17, 18], "url": [0, 9, 13], "pep": [0, 3, 12, 16], "0008": 0, "0257": 0, "particular": [0, 2, 3, 4, 5, 7, 9, 11, 12, 13], "4": [0, 1, 2, 3, 4, 7, 9, 11, 12, 13, 16], "space": [0, 2, 3, 13, 16, 17], "indent": [0, 16], "level": [0, 3, 4, 11, 13], "do": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 17, 18], "tab": [0, 5, 9, 13, 14], "thei": [0, 2, 3, 4, 5, 7, 9, 11, 12, 13, 14, 18], "can": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19], "result": [0, 1, 2, 3, 4, 7, 9, 12, 13, 15], "confus": [0, 3, 4, 13], "most": [0, 1, 2, 3, 4, 5, 7, 8, 9, 11, 12, 13, 15, 17], "editor": [0, 5, 10, 17], "have": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 15, 17, 18, 19], "featur": [0, 1, 3, 5, 6, 9, 10, 12, 14], "insert": [0, 5, 7, 12, 17], "kei": [0, 3, 9, 11, 13, 19], "hit": [0, 7, 13, 14], "also": [0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12, 13, 17, 18, 19], "automat": [0, 1, 4, 7, 9, 10, 11, 12, 15, 16, 18], "search": [0, 4, 9, 10, 12, 13], "replac": [0, 2, 3, 8, 9, 11, 12, 13, 14, 15, 17], "lead": [0, 3, 7, 13, 16, 17], "befor": [0, 4, 5, 7, 9, 10, 11, 13, 14, 16, 17, 18], "after": [0, 2, 3, 4, 5, 7, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19], "assign": 0, "binari": [0, 11, 13], "oper": [0, 2, 3, 5, 7, 9, 13, 16, 18], "lowest": [0, 12], "prioriti": [0, 9, 14], "express": [0, 12, 13, 16], "c": [0, 1, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 17], "b": [0, 1, 2, 3, 5, 7, 11, 15, 17, 18], "No": [0, 4, 9, 10, 11, 14], "sign": [0, 17], "keyword": [0, 3, 9, 16], "argument": [0, 1, 3, 10, 11, 13, 16, 17], "def": [0, 1, 2, 3, 4, 7, 12], "complex": [0, 11], "real": [0, 3, 4, 11, 13, 15], "imag": [0, 7, 9, 10], "0": [0, 1, 2, 4, 5, 7, 10, 11, 12, 13, 16, 18], "return": [0, 1, 2, 4, 7, 9, 10, 12, 13], "magic": [0, 6], "r": [0, 2, 3, 4, 5, 7, 9, 13, 14], "immedi": [0, 1, 17], "insid": [0, 11, 13], "parenthesi": 0, "bracket": 0, "brace": 0, "spam": 0, "ham": 0, "egg": [0, 16], "2": [0, 1, 2, 3, 4, 5, 6, 7, 9, 11, 12, 13, 14, 16, 18], "rang": [0, 1, 2, 7, 11, 12], "3": [0, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 16], "lowercas": 0, "name": [0, 2, 3, 4, 5, 6, 7, 8, 9, 12, 13, 17, 18], "word": [0, 6, 9, 11, 16], "separ": [0, 2, 5, 9, 11, 12, 13, 16], "underscor": [0, 3, 11, 12, 15], "For": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 19], "you": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 13, 14, 15, 16, 17, 18, 19], "encourag": [0, 10, 11, 13], "set_some_valu": 0, "howev": [0, 1, 2, 3, 4, 5, 7, 10, 11, 12, 13, 14, 17, 18], "some": [0, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 19], "uppercas": 0, "letter": [0, 2, 15], "where": [0, 2, 3, 4, 5, 6, 9, 10, 12, 13, 15, 17, 18], "instanc": [0, 1, 2, 3, 14, 17], "lattic": [0, 4], "reduct": 0, "lll": 0, "call": [0, 1, 2, 3, 4, 5, 6, 7, 9, 11, 12, 13], "matrix_integer_dens": 0, "camelcas": 0, "class": [0, 1, 2, 3, 10, 11, 12, 14, 15], "somevalu": 0, "__init__": [0, 2, 3, 4, 12, 15], "self": [0, 1, 2, 3, 4], "x": [0, 2, 3, 4, 5, 7, 12, 13, 14], "_x": 0, "factori": [0, 3], "mimic": 0, "constructor": [0, 4], "polynomialr": [0, 2], "someidentityvalu": 0, "roughli": [0, 12], "tree": [0, 5, 7, 11, 12, 13, 17], "layout": [0, 11], "like": [0, 1, 2, 3, 4, 5, 6, 7, 9, 11, 12, 13, 14, 17, 18], "we": [0, 1, 2, 3, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14, 16, 17, 18, 19], "sage_root": [0, 2, 3, 4, 11, 12, 13, 15, 16, 17], "shortcut": [0, 5, 6, 11, 17], "arbitrari": [0, 9, 13], "contain": [0, 2, 3, 4, 5, 6, 9, 10, 11, 12, 14, 15, 16, 17], "sourc": [0, 2, 3, 4, 5, 9, 10, 13, 14, 15, 16, 18], "launcher": 0, "makefil": [0, 4, 11, 13, 15], "top": [0, 3, 4, 5, 9, 11, 12, 13, 18], "build": [0, 1, 3, 4, 9, 10, 14, 17, 19], "system": [0, 2, 3, 4, 6, 7, 9, 12, 14, 16, 17], "pkg": [0, 3, 11, 12, 13, 16], "instal": [0, 1, 3, 4, 5, 10, 12, 15, 16, 17, 19], "patch": [0, 4, 14], "metadata": [0, 3, 12], "from": [0, 1, 2, 5, 6, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19], "spkg": [0, 3, 12, 13], "src": [0, 2, 3, 4, 7, 11, 12, 13, 15, 16, 17], "setup": [0, 3, 11, 12], "ext_data": 0, "extra": [0, 4, 7, 12, 13], "resourc": [0, 3, 8, 9, 13], "formerli": [0, 16], "ext": [0, 11, 12], "bin": [0, 3, 4, 7, 11, 12, 13], "local": [0, 4, 5, 7, 9, 10, 11, 12, 15, 16, 17, 18, 19], "track": [0, 3, 4, 5, 6, 11, 14, 17], "upstream": [0, 5, 6, 7, 9, 10, 13, 16, 17], "tarbal": [0, 12, 13, 14], "goe": [0, 4, 14], "mai": [0, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12, 13, 14, 17, 18, 19], "plural": 0, "e": [0, 1, 2, 3, 4, 5, 6, 7, 9, 11, 12, 14, 15, 16], "g": [0, 1, 2, 3, 5, 6, 9, 11, 13, 14, 15, 16, 17], "ring": [0, 1, 2, 3, 4, 12], "almost": [0, 2], "alwai": [0, 2, 3, 4, 5, 9, 14, 17], "singular": [0, 4, 10, 12], "polynomial_r": 0, "might": [0, 2, 3, 4, 6, 11, 13], "still": [0, 3, 4, 5, 10, 11, 12, 13, 14, 17, 19], "sever": [0, 1, 4, 9, 11, 12, 13, 14, 15], "differ": [0, 1, 2, 3, 7, 9, 10, 11, 12, 14, 15, 16, 17], "type": [0, 1, 2, 3, 4, 5, 9, 10, 12, 13, 15, 16, 17], "polynomi": [0, 2, 3, 4], "email": [0, 5, 6, 8, 17], "your": [0, 1, 2, 3, 4, 5, 6, 8, 10, 11, 13, 14, 15, 16, 17, 18], "plain": [0, 16], "text": [0, 10, 15, 16, 17], "extens": [0, 1, 2, 3, 4, 7, 11, 13, 16], "txt": [0, 11, 12, 13, 16, 17], "subdirectori": [0, 11, 12, 13, 15, 16], "If": [0, 2, 3, 4, 5, 7, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18], "want": [0, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 15, 17, 18], "creat": [0, 1, 3, 4, 5, 6, 7, 10, 12, 13, 15, 17, 19], "sai": [0, 1, 2, 3, 4, 5, 7, 12, 13, 15], "measure_theori": 0, "usual": [0, 3, 5, 11, 14, 15, 16], "an": [0, 1, 2, 3, 4, 5, 6, 7, 10, 11, 12, 13, 14, 15, 16, 17, 19], "empti": [0, 5, 7, 11, 12, 13, 17], "which": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 15, 17, 19], "mark": [0, 3, 4, 7, 9, 11, 12, 13, 17, 18], "ordinari": 0, "implicit": 0, "namespac": [0, 3, 4, 15], "import": [0, 1, 2, 4, 9, 10, 11, 12, 14, 15, 17], "user": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 14, 16, 17, 18], "face": 0, "enough": [0, 3, 4, 11, 12, 13, 14, 18], "startup": [0, 3, 4], "look": [0, 1, 2, 3, 5, 7, 9, 11, 12, 13, 14, 17, 18], "borel_measur": 0, "borelmeasur": 0, "banach_tarski": 0, "banachtarskiparadox": 0, "better": [0, 3, 7, 9, 11, 17], "lazy_import": [0, 3, 12], "misc": [0, 3, 9, 12, 13], "Then": [0, 1, 2, 3, 4, 5, 7, 9, 11, 12, 13, 17, 18], "add": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18], "line": [0, 1, 2, 3, 4, 5, 6, 8, 9, 11, 13, 14, 15, 16, 17], "ad": [0, 2, 4, 5, 6, 9, 10, 11, 12, 13, 14, 16, 17], "below": [0, 1, 2, 3, 10, 11, 13, 16], "done": [0, 2, 3, 4, 5, 7, 9, 11, 12, 13, 14, 17, 18], "sparingli": [0, 14], "often": [0, 1, 3, 4, 11, 12], "subpackag": 0, "exist": [0, 2, 3, 4, 5, 9, 10, 11, 13, 14], "non": [0, 2, 6, 7, 11, 12, 13], "support": [0, 3, 9, 11, 12, 13, 14, 15], "one": [0, 1, 2, 3, 4, 5, 7, 9, 11, 12, 13, 14, 15, 16, 17], "place": [0, 2, 3, 4, 11, 13, 17], "same": [0, 1, 2, 3, 4, 5, 6, 7, 9, 11, 12, 13, 15, 16, 17], "locat": [0, 11, 12, 13, 15], "interfac": [0, 1, 3, 9, 10, 13, 18], "maxima": [0, 12], "need": [0, 1, 2, 3, 4, 5, 6, 9, 10, 11, 12, 13, 14, 15, 17, 18, 19], "lisp": [0, 2, 14], "runtim": [0, 4, 11], "so": [0, 1, 2, 3, 4, 5, 9, 10, 11, 12, 13, 14, 16, 17, 18], "refer": [0, 2, 3, 7, 9, 10, 11, 13, 14, 15], "o": [0, 2, 5, 7, 11, 16], "path": [0, 11, 13, 15, 16, 17], "join": 0, "dirnam": 0, "__file__": 0, "appropri": [0, 2, 9, 11, 14, 18], "At": [0, 2, 11, 13, 16], "avail": [0, 1, 2, 3, 5, 6, 7, 9, 11, 12, 13, 16, 17], "indic": [0, 3, 9, 11, 12, 13, 14], "sage_extcod": 0, "env": [0, 11, 12, 13, 19], "both": [0, 7, 11, 12, 13, 14], "case": [0, 2, 3, 4, 7, 9, 11, 12, 13, 14, 15, 17], "must": [0, 1, 2, 3, 4, 7, 9, 10, 11, 12, 14, 15, 17, 18], "explicitli": [0, 3, 4, 13, 17, 18], "via": [0, 3, 4, 7, 11, 12, 13, 18], "wildcard": 0, "section": [0, 2, 3, 4, 5, 6, 7, 8, 11, 13, 17], "package_data": 0, "cfg": [0, 3, 11, 12], "m4": [0, 3, 11, 12, 13], "anoth": [0, 3, 4, 5, 10, 11, 12, 13, 14, 15, 17], "here": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 13, 14, 15], "find": [0, 2, 4, 9, 10, 12, 13, 14, 17], "brows": 0, "through": [0, 2, 3, 4, 5, 9, 10, 11, 12, 13, 14, 18], "help": [0, 3, 4, 6, 7, 8, 9, 10, 13, 14, 15, 16, 17], "search_src": 0, "search_def": 0, "search_doc": 0, "worth": 0, "know": [0, 3, 4, 9, 10, 13, 14, 17], "briefli": [0, 9], "prompt": [0, 2, 12, 13, 18], "command": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 11, 12, 13, 15, 16, 17, 18], "doe": [0, 2, 3, 5, 7, 9, 11, 12, 13, 14, 15, 16, 17], "similar": [0, 1, 3, 4, 11, 12, 13, 16], "restrict": [0, 2], "while": [0, 1, 2, 3, 4, 7, 9, 10, 11, 12, 13, 14, 15, 16, 19], "more": [0, 1, 2, 3, 4, 6, 7, 9, 11, 12, 13, 14, 15, 16, 17], "each": [0, 2, 3, 4, 5, 9, 11, 12, 13, 14, 16, 17], "short": [0, 4, 5, 9, 15], "summari": [0, 4, 10, 16, 17], "end": [0, 2, 4, 5, 13, 14, 16, 17], "period": 0, "paragraph": 0, "descript": [0, 11, 12, 15, 17], "lot": [0, 1, 4, 9, 12], "author": [0, 2, 4, 5, 9, 11, 13, 14, 19], "2005": [0, 2], "01": [0, 1, 4], "03": [0, 4, 11, 13], "initi": [0, 3, 4, 6, 7, 12, 13], "version": [0, 1, 2, 3, 4, 7, 9, 10, 13, 15, 16, 17], "person": [0, 6, 9, 13], "date": [0, 1, 5, 6, 11, 13, 17], "iso": 0, "year": [0, 3, 11], "month": 0, "dai": [0, 11], "desc": 0, "copyright": [0, 4], "2013": [0, 4, 5], "program": [0, 1, 2, 3, 4, 7, 11, 17], "free": [0, 4, 10, 11, 14, 17, 19], "softwar": [0, 2, 4, 9, 10, 11, 12, 13, 15], "redistribut": [0, 4, 11], "modifi": [0, 4, 5, 7, 10, 14, 15, 17], "under": [0, 4, 7, 10, 11, 13, 15, 16, 17], "term": [0, 3, 7], "gnu": [0, 4, 11, 13], "public": [0, 5, 9, 11, 13, 19], "licens": [0, 4, 10, 12], "publish": [0, 10], "foundat": [0, 4, 11], "either": [0, 3, 4, 5, 7, 11, 12, 13], "ani": [0, 1, 2, 3, 4, 5, 7, 9, 11, 12, 13, 14, 17], "later": [0, 3, 4, 5, 13, 16], "As": [0, 1, 2, 3, 4, 5, 7, 10, 11, 12, 13, 16, 17], "integ": [0, 1, 2, 4, 5, 10, 15], "zz": [0, 2, 12], "peopl": [0, 9], "who": [0, 9, 10, 11, 12, 17], "made": [0, 1, 3, 5, 6, 7, 10, 11, 14, 15, 17, 18], "major": [0, 1, 9, 13], "appear": [0, 3, 4, 9, 12, 13, 15, 16], "belong": [0, 14, 15], "refrain": [0, 14], "being": [0, 3, 5, 10, 11, 12], "verbos": [0, 4], "show": [0, 2, 7, 9, 12, 13, 14, 16, 17], "veri": [0, 1, 2, 3, 5, 6, 7, 9, 12, 13, 16, 17], "rough": 0, "overview": [0, 10, 17], "histori": [0, 6, 7, 10], "especi": 0, "been": [0, 1, 2, 3, 4, 7, 9, 10, 11, 12, 13, 14, 15, 16], "authorit": 0, "log": [0, 4, 5, 7, 9, 12, 13, 16, 17, 19], "wrote": [0, 9, 11], "what": [0, 1, 3, 4, 5, 9, 10, 11, 12, 13, 14, 16, 17, 18], "git": [0, 4, 11, 12, 13, 14, 16, 19], "repositori": [0, 5, 7, 10, 11, 12, 13, 14, 17, 18], "output": [0, 1, 2, 3, 4, 13, 14, 15, 16], "blame": 0, "gplv2": 0, "compat": [0, 2, 3, 11, 13], "less": [0, 4, 7], "bsd": [0, 13], "A": [0, 1, 2, 4, 5, 6, 7, 9, 10, 11, 12, 13, 15, 17], "sentenc": 0, "blank": [0, 16], "describ": [0, 3, 4, 9, 11, 13, 16, 18], "method": [0, 1, 2, 10, 12, 14, 15, 16], "effect": [0, 17], "pathnam": 0, "recommend": [0, 4, 8, 11, 13, 14], "unless": [0, 2, 3, 4, 14, 17], "prefer": [0, 2, 3, 9, 12, 13, 14], "whether": [0, 2, 4, 7, 9, 11, 12, 13, 16, 17], "prime": [0, 2, 3, 17, 18], "longer": [0, 4, 5, 11, 14], "explan": [0, 14], "start": [0, 1, 2, 3, 4, 5, 7, 9, 10, 11, 12, 13, 14, 16, 17, 19], "assumpt": [0, 3], "poset": 0, "expect": [0, 2, 4, 9, 11, 13, 14, 16], "rank": [0, 2], "rais": [0, 2, 3, 4, 7, 9], "except": [0, 2, 4, 6, 10, 11, 12, 13, 16, 17], "defin": [0, 1, 2, 3, 4, 11, 12, 13, 15, 16], "lexicograph": 0, "product": [0, 16], "h": [0, 2, 4, 6, 9, 13, 15], "graph": [0, 3, 6, 7, 12], "vertex": 0, "set": [0, 2, 3, 4, 5, 6, 7, 9, 10, 12, 13, 14, 16, 17, 18], "mention": [0, 3, 9, 12], "possibl": [0, 2, 3, 4, 5, 6, 8, 9, 11, 12, 13, 14], "alias": 0, "tensor": [0, 12], "known": [0, 4, 11, 12, 13, 16, 17], "categor": 0, "input": [0, 1, 2, 3, 4, 14], "accept": [0, 3, 4, 11, 12], "repres": [0, 2, 3, 12, 13], "exact": [0, 15, 17], "anyth": [0, 1, 3, 4, 9, 12, 13, 19], "behav": 0, "rather": [0, 3, 4, 7, 9, 11, 12], "than": [0, 1, 2, 3, 4, 7, 9, 11, 12, 14, 17], "int": [0, 1, 2, 3], "default": [0, 2, 3, 4, 7, 9, 11, 12, 13, 15, 16, 17], "valu": [0, 2, 4, 7, 10, 11, 13, 17], "applic": [0, 13], "n": [0, 1, 2, 3, 4, 5, 12, 16], "p": [0, 2, 3, 4, 5, 9, 13, 14, 16], "coprim": 0, "requir": [0, 2, 3, 4, 5, 7, 9, 11, 12, 14, 16, 17], "plaintext": 0, "decrypt": 0, "ciphertext": 0, "item": [0, 3, 4, 9, 13], "tupl": [0, 1, 2, 3, 4, 12], "reduc": [0, 3, 4, 12, 16], "echelon": 0, "form": [0, 2, 3, 11, 12, 13, 15], "matrix": [0, 2], "transform": 0, "u": [0, 2, 4, 5, 7, 9, 10, 11, 12, 13, 16], "ua": 0, "complic": [0, 3, 7], "decomposit": 0, "modul": [0, 3, 10, 11, 15, 16], "act": [0, 18], "right": [0, 3, 6, 7, 11, 13, 18], "action": [0, 9, 10, 14], "xa": 0, "along": [0, 9, 11], "irreducibli": 0, "factor": [0, 3, 13], "guarante": [0, 13, 14], "sort": [0, 2, 4, 11], "characterist": [0, 2, 12], "These": [0, 1, 2, 4, 5, 11, 12, 13, 14, 18], "releas": [0, 3, 4, 7, 9, 10, 11, 12, 17, 18], "good": [0, 3, 6, 9, 10, 11, 12, 13, 14, 17], "coverag": [0, 4, 10, 14], "question": [0, 9, 12, 14], "seealso": 0, "highli": [0, 9, 11, 14], "relat": [0, 9, 12, 14, 16], "part": [0, 2, 3, 4, 10, 11, 12, 13, 17], "interest": [0, 9], "them": [0, 3, 4, 5, 7, 9, 11, 12, 13, 14, 15, 17], "discov": 0, "ones": [0, 3, 7, 9, 11, 12], "ref": [0, 7, 18], "sage_manuals_link": 0, "meth": [0, 15], "somewher": 0, "other_useful_method": 0, "mod": [0, 3, 15], "hyperlink": [0, 10, 14], "detail": [0, 2, 3, 4, 6, 7, 9, 10, 11, 12, 13, 15, 16, 17, 18], "pari": [0, 10, 11, 12, 14], "bibliograph": 0, "adapt": [0, 13], "page": [0, 1, 8, 9, 10, 13, 15, 18], "89": [0, 4, 7], "nat2000": 0, "_": [0, 15], "let": [0, 2, 4, 5, 7, 9, 11, 12, 13, 19], "odd": 0, "posit": [0, 9, 12, 13, 14, 18], "modulo": [0, 2, 16], "k": [0, 4, 13], "onli": [0, 2, 3, 5, 7, 9, 11, 13, 14, 16, 17], "gcd": 0, "sinc": [0, 2, 3, 4, 5, 7, 11, 18], "even": [0, 1, 2, 3, 4, 5, 11, 12, 13], "between": [0, 1, 2, 3, 4, 7, 11, 15, 17], "inclus": [0, 3, 10, 14, 18], "rel": [0, 3, 4, 6, 12], "now": [0, 1, 2, 4, 5, 6, 7, 8, 10, 11, 12, 13, 14, 15, 17, 18, 19], "narrow": [0, 12], "our": [0, 2, 3, 4, 5, 9, 10, 11, 12, 14, 16, 17, 18], "go": [0, 3, 5, 6, 9, 10, 11, 12, 13, 14, 17, 18, 19], "doc": [0, 3, 4, 7, 9, 11, 13, 15, 16], "en": [0, 4, 11, 13, 15, 16], "index": [0, 2, 10, 15, 16, 17], "rst": [0, 4, 12, 15, 16], "m": [0, 2, 5, 7, 11, 13], "nathanson": 0, "elementari": [0, 2], "theori": 0, "springer": 0, "2000": 0, "tip": [0, 8, 10], "trick": [0, 1], "least": [0, 4, 11], "never": [0, 5, 7, 10, 11], "charact": [0, 2, 11, 13], "warn": [0, 3, 4, 9, 11, 13, 15, 16], "critic": [0, 9, 11, 14], "situat": [0, 4, 10], "break": [0, 10, 11], "awar": [0, 14, 16], "whenev": [0, 1, 3, 4, 9, 11, 12, 17], "sure": [0, 4, 9, 11, 12, 13, 17], "That": [0, 2, 5, 14, 17], "ensur": [0, 1, 3, 4, 7, 11, 13, 14, 17], "pdf": [0, 11, 14, 15, 16], "updat": [0, 3, 6, 9, 12, 13, 15, 17, 18], "fail": [0, 1, 3, 4, 7, 9, 11, 13, 16, 17], "would": [0, 2, 3, 4, 5, 7, 9, 11, 12, 13, 14, 15, 16, 18], "request": [0, 6, 10, 13, 14, 18], "chang": [0, 1, 2, 3, 5, 6, 9, 10, 11, 12, 13, 14, 15, 16, 17, 19], "todo": [0, 13], "futur": [0, 3, 5, 9, 11], "disabl": [0, 4, 9, 11, 17], "demonstr": [0, 2, 4], "desir": [0, 12], "have_fresh_b": 0, "faster": [0, 1, 2, 12, 17], "bui": 0, "fridg": 0, "babf": 0, "bi\u00e8r": 0, "de": [0, 7, 15, 16], "l": [0, 2, 3, 4, 12, 13, 16], "yvett": 0, "enjoi": 0, "plot": [0, 4, 12], "illustr": [0, 2, 3, 9, 14], "pictur": 0, "sphinx_plot": 0, "petersengraph": 0, "book": [0, 6, 8], "paper": 0, "put": [0, 1, 2, 3, 9, 11, 13], "citat": 0, "reader": 0, "syntax": [0, 2, 3, 4, 10, 11], "individu": [0, 11], "therefor": [0, 3, 12, 13], "necessari": [0, 1, 4, 5, 7, 11, 12, 13, 17], "nevertheless": 0, "relev": [0, 3, 4, 9], "particularli": 0, "long": [0, 2, 3, 5, 7, 9, 10, 11, 13, 14, 16, 17], "alreadi": [0, 2, 3, 5, 7, 9, 11, 12, 13, 14, 16, 17], "present": [0, 2, 11, 12, 17], "str1969": 0, "sto2000": 0, "voe2003": 0, "trail": [0, 3, 16], "github": [0, 3, 5, 6, 8, 11, 12, 14, 15, 16, 17, 19], "issu": [0, 3, 4, 7, 10, 11, 12, 13, 14, 15, 16, 19], "pr": [0, 3, 10, 11, 12, 13, 16], "wikipedia": [0, 15], "shown": [0, 1, 3, 4, 7, 12, 13, 18], "ask": [0, 9, 13, 14], "foo": [0, 3, 9, 11], "strip": 0, "sagedoc": 0, "skip_tests_block": 0, "corner": [0, 14], "zero": [0, 11, 13], "element": [0, 2, 3], "group": [0, 2, 9, 11], "valid": [0, 1, 9, 11, 16], "up": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 16, 17], "down": [0, 3, 4, 13, 14], "check": [0, 1, 2, 4, 5, 10, 11, 13, 14, 16], "junk": 0, "purpos": [0, 2, 4, 9, 10, 11, 12, 13, 14, 16], "remov": [0, 3, 5, 11, 12, 13], "two": [0, 2, 3, 4, 5, 7, 11, 12, 13, 14, 15, 16], "colon": 0, "its": [0, 1, 3, 4, 5, 7, 9, 10, 11, 12, 13, 15, 17], "own": [0, 4, 6, 7, 9, 10, 11, 12, 13, 17], "match": [0, 4, 12], "header": [0, 11], "hyphen": [0, 13], "equal": [0, 3, 6, 16], "marker": [0, 7], "doubl": [0, 3], "sometim": [0, 1, 2, 4, 5, 7, 11, 12], "rare": [0, 11, 17, 18], "ha": [0, 1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 15, 16], "protect": [0, 7], "don": [0, 1, 3, 4, 5, 7, 9, 11, 13, 14, 17, 18], "t": [0, 1, 2, 3, 4, 5, 7, 9, 11, 13, 14, 16, 17, 18], "proper": 0, "tradit": 0, "pytest": [0, 10], "latter": [0, 11, 13], "main": [0, 4, 11, 12, 13], "math": [0, 3, 4], "rubric": 0, "topic": [0, 10, 11], "written": [0, 3, 11, 14, 15, 18], "exactli": [0, 2, 5, 11, 12, 14], "abov": [0, 2, 3, 4, 6, 7, 9, 10, 11, 12, 13, 14, 16], "frequent": [0, 5], "moduleauthor": 0, "automethod": 0, "autofunct": 0, "figur": [0, 1, 2, 3], "shall": 0, "restructuredtext": [0, 15, 16], "process": [0, 2, 3, 4, 9, 10, 11, 13, 16, 17], "introduct": [0, 6, 13, 18], "impos": [0, 12], "shorter": [0, 2], "80": [0, 4, 7, 14], "doubt": [0, 7], "pep8": [0, 16], "maximum": [0, 4], "length": 0, "fragment": 0, "quot": 0, "backtick": 0, "liter": [0, 3], "true": [0, 1, 3, 4, 6, 11, 12, 16], "fals": [0, 1, 2, 3, 5, 12], "none": [0, 2, 3, 11, 12, 16], "store": [0, 2, 4, 5, 7, 9, 15, 17], "gau1801": 0, "f": [0, 1, 2, 4, 5, 11, 13, 19], "gauss": 0, "disquisition": 0, "arithmetica": 0, "1801": 0, "rsa1978": 0, "rivest": 0, "shamir": 0, "adleman": 0, "obtain": [0, 3, 10, 11, 13], "digit": [0, 5, 7, 15], "signatur": 0, "cryptosystem": [0, 4], "commun": [0, 2, 7, 10, 17], "acm": 0, "21": [0, 4, 5], "februari": [0, 10], "1978": 0, "120": 0, "126": [0, 12], "doi": [0, 15], "10": [0, 1, 2, 3, 4, 11, 13, 14, 15], "1145": 0, "359340": 0, "359342": 0, "given": [0, 2, 3, 4, 11, 13, 14], "could": [0, 1, 2, 3, 4, 10, 12, 14], "first": [0, 1, 2, 3, 5, 7, 9, 11, 12, 13, 14, 16, 17, 18, 19], "singl": [0, 1, 3, 4, 9, 11, 12, 15], "three": [0, 5, 7, 16], "famili": [0, 2], "multipl": [0, 4, 7, 10, 11, 16, 17], "four": [0, 4], "last": [0, 2, 3, 4, 5, 11, 13, 14, 17, 18], "1910": 0, "2010": 0, "abbrevi": [0, 5], "backslash": 0, "front": [0, 4], "interpret": [0, 1, 2], "enumer": [0, 7, 9, 18], "y": [0, 2, 3, 4, 7, 13], "5": [0, 1, 2, 3, 4, 5, 8, 9, 11, 12, 13, 16], "begin": [0, 1, 3, 10, 11, 13, 14, 17], "modulispac": 0, "xxx": 0, "6": [0, 1, 2, 4, 11, 12, 13, 18], "error": [0, 2, 3, 4, 5, 7, 9, 11, 12, 13, 14, 15, 16, 17], "7": [0, 2, 3, 4, 7, 11, 12, 13, 16, 18], "traceback": [0, 3, 4], "recent": [0, 3, 4, 5, 7, 8, 9, 11, 13], "typeerror": [0, 2], "unabl": [0, 13], "convert": [0, 2, 4, 6, 12], "bcdt2001": 0, "determin": [0, 2, 4, 11, 12, 13, 14], "ellipt": [0, 11], "curv": [0, 2, 4, 11, 13], "over": [0, 1, 2, 3, 10, 11, 16], "q": [0, 4], "modular": [0, 3, 12, 16], "func": [0, 15], "42": [0, 4, 13, 16], "bodi": [0, 9, 18], "breuil": 0, "conrad": 0, "diamond": 0, "taylor": 0, "strongli": [0, 8, 11], "liber": 0, "explanatori": [0, 17], "next": [0, 2, 4, 9, 12, 13, 14, 17, 18], "crucial": [0, 13], "qualiti": [0, 11, 14, 17], "without": [0, 1, 2, 3, 4, 5, 7, 9, 11, 12, 13, 14, 15, 17, 19], "small": [0, 3, 12, 13, 14], "someth": [0, 3, 4, 7, 9, 10, 11, 12, 14], "els": [0, 2, 3, 4, 7, 9, 11, 14, 17, 18], "seen": 0, "until": [0, 2, 3, 7, 9, 17], "much": [0, 1, 2, 3, 4, 7, 9, 11, 12, 17], "someon": [0, 7, 9, 11, 14, 18], "unaccept": [0, 2], "develop": [0, 1, 2, 3, 4, 5, 6, 9, 11, 12, 14, 15, 19], "suggest": [0, 3, 7, 11, 14], "manual": [0, 2, 3, 10, 11, 14, 16, 17, 18], "reason": [0, 2, 3, 4, 9, 10, 11, 12], "did": [0, 5, 7, 11, 13, 14, 18], "reach": [0, 11, 17], "agreement": [0, 9], "offici": [0, 16], "second": [0, 1, 3, 4, 5, 7, 13, 16], "tight": [0, 2, 12], "third": [0, 2, 3, 5, 7, 10, 17], "opinion": 0, "realiti": 0, "codebas": [0, 16], "decid": [0, 7, 9, 12, 14], "vote": 0, "prevent": [0, 3, 6, 9, 11, 14], "disput": 0, "conflict": [0, 5, 10, 14, 17, 18], "acknowledg": 0, "respect": [0, 3, 11, 12, 13, 14, 15], "choic": [0, 3, 13], "whose": [0, 2, 9, 11, 13], "consid": [0, 3, 4, 5, 7, 9, 11, 12, 13, 14], "sageobject": [0, 3], "_f": 0, "hidden": 0, "due": [0, 9], "statu": [0, 5, 6, 10, 11, 13, 14, 17, 18], "construct": [0, 2, 12, 15, 16], "sageinspect": 0, "sage_getdoc": 0, "allow": [0, 1, 2, 3, 4, 5, 9, 12, 13, 14, 17], "yield": 0, "instead": [0, 3, 4, 5, 7, 9, 11, 12, 13, 15, 16, 17, 18], "co": [0, 6], "sin": 0, "sum_": 0, "infti": 0, "a_1": 0, "a_2": 0, "cdot": 0, "a_i": 0, "leq": 0, "align": 0, "environ": [0, 4, 6, 10, 11, 13, 16, 19], "everyth": [0, 2, 3, 5, 7, 11, 12, 13, 14, 17], "translat": [0, 1, 2, 10, 15], "wrap": [0, 2], "turn": [0, 5, 7, 14], "nowrap": 0, "flag": [0, 2, 4, 11, 15, 16], "mode": [0, 3, 5, 11, 17], "readabl": [0, 2], "balanc": 0, "interact": [0, 2, 3, 4, 9, 10, 12, 13], "consol": [0, 2], "formula": [0, 7, 13], "frac": [0, 3], "pleasant": 0, "everybodi": [0, 10], "manag": [0, 4, 6, 8, 9, 11, 12, 13, 14], "common": [0, 2, 4, 6, 7, 10, 11, 12, 16, 18], "bold": [0, 6], "z": [0, 3, 4, 7], "field": [0, 2, 3, 4, 11, 12], "macro": [0, 2, 3, 11, 12], "give": [0, 3, 4, 5, 6, 9, 10, 11, 12, 13, 14, 15, 16], "preserv": 0, "rr": [0, 2], "cc": 0, "qq": [0, 2, 3, 16], "gf": [0, 2, 4], "zmod": 0, "latex_macro": 0, "usag": [0, 4, 16, 17], "avoid": [0, 2, 3, 5, 9, 11, 12, 13, 14, 15, 16, 17], "bug": [0, 4, 6, 10, 11, 14], "pass": [0, 4, 11, 13, 14, 15, 16], "your_fil": 0, "messag": [0, 3, 5, 6, 7, 9, 11, 13, 15, 17], "instruct": [0, 7, 11, 13, 17, 19], "lost": [0, 5], "occas": 0, "famou": 0, "theorem": 0, "is_prim": 0, "proof": 0, "meaning": [0, 11, 12], "combin": [0, 4, 11, 13, 17], "involv": [0, 2, 3, 7, 9, 10, 14], "abl": [0, 3, 6, 7, 11, 14], "handl": [0, 2, 10], "null": 0, "broken": [0, 14, 15], "probabl": [0, 2, 12, 17, 18], "size": [0, 2, 11, 13], "random": [0, 2, 3, 7], "testsuit": [0, 4, 12, 13], "specif": [0, 3, 9, 11, 12, 13, 14, 15, 16, 17], "sage_unittest": 0, "aa": 0, "algebra": [0, 2, 3, 9, 12, 13], "steenrod": 0, "steenrod_algebra": [0, 3], "milnor": 0, "basi": [0, 2, 3], "henc": [0, 3, 5, 7, 12, 13, 14, 17], "prepars": [0, 4, 10, 12], "3333333333333333": 0, "8": [0, 1, 2, 3, 4, 11, 12, 13, 16], "occur": [0, 4, 14, 17, 18], "within": [0, 1, 3, 10, 12, 13], "shell": [0, 2, 5, 7, 11, 13, 17], "temporari": [0, 11], "tmp_filenam": 0, "get": [0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11, 13, 14, 19], "filenam": [0, 4, 11, 13], "tmp_dir": 0, "graphic": 0, "ymin": 0, "save": [0, 1, 5, 6, 7, 13, 17, 19], "png": [0, 16], "multilin": 0, "span": 0, "continu": [0, 4, 5, 11, 13, 16, 17, 18], "srang": 0, "print": [0, 2, 4, 9, 11, 13], "python3": [0, 3, 4, 7, 11, 12, 13], "old": [0, 3, 4, 5, 9, 13], "syntaxerror": 0, "split": [0, 12], "123456789123456789123456789": 0, "behaviour": [0, 3, 4, 9], "overli": 0, "shorten": [0, 4, 6], "ellipsi": 0, "ordinal_str": 0, "25": [0, 4, 13, 16, 18], "0th": 0, "1st": 0, "2nd": 0, "3rd": 0, "4th": 0, "5th": 0, "21st": 0, "22nd": 0, "23rd": 0, "24th": 0, "On": [0, 4, 9, 11, 13, 15, 16, 17], "comment": [0, 4, 5, 10, 11, 12, 13, 14, 16, 18], "verifi": [0, 13, 16, 17], "comprehens": [0, 15], "execut": [0, 2, 4, 5, 11, 12, 16], "combinatorialobject": 0, "hash": [0, 3, 5, 7], "1335416675971793195": 0, "too": [0, 3, 5, 9, 11, 12, 16], "state": [0, 3, 5, 7, 9, 13, 14, 17], "pseudorandom": 0, "prng": 0, "problem": [0, 1, 3, 4, 7, 9, 11, 13, 14], "successfulli": [0, 2, 5, 13], "dict": [0, 3], "One": [0, 2, 3, 7, 11, 14], "tag": [0, 4, 12, 13, 14, 17], "basic": [0, 1, 2, 5, 8, 9, 10, 12], "properti": [0, 3], "random_el": 0, "parent": [0, 3, 5, 7, 11, 12], "_random_nonzero_el": 0, "loop": [0, 2, 3, 7, 12], "found": [0, 3, 9, 11, 15, 16, 17], "correct": [0, 2, 4, 7, 11, 14], "termin": [0, 4, 9, 13, 17], "nonzero": 0, "timout": 0, "time": [0, 1, 2, 3, 4, 7, 9, 10, 11, 13, 14, 16, 17, 18, 19], "take": [0, 2, 3, 4, 5, 12, 13, 14, 16, 17, 19], "30": [0, 4, 9, 13], "ellipticcurv": [0, 4], "regul": 0, "0511114082399688": 0, "tol": [0, 3], "toler": 0, "numer": [0, 2, 3, 16], "subject": [0, 2, 3, 9, 11, 13, 14], "nois": 0, "depend": [0, 2, 3, 4, 5, 7, 8, 9, 10, 13, 14, 16, 17, 19], "float": [0, 3], "arithmet": [0, 3, 9], "determinist": 0, "prefix": [0, 9, 11, 12, 13], "ab": 0, "olut": 0, "ativ": 0, "specifi": [0, 4, 5, 15, 16, 18], "measur": [0, 9, 14], "absolut": [0, 3, 15], "articl": [0, 15], "approximation_error": 0, "pi": [0, 3], "1e": [0, 3], "9": [0, 2, 3, 4, 7, 11, 12, 13, 16], "14159265358979": 0, "41593": 0, "zeta8": 0, "cyclotomicfield": 0, "7071067812": 0, "represent": [0, 2], "matric": [0, 2, 3], "sum": [0, 12], "001": 0, "expand": 0, "ident": [0, 5, 7, 13], "random_matrix": 0, "comput": [0, 2, 3, 4, 5, 7, 13, 14, 17, 19], "regular": [0, 13, 16], "float_regex": 0, "pars": [0, 2, 4], "meant": [0, 3, 14], "eventu": [0, 3], "current": [0, 4, 5, 6, 7, 9, 10, 11, 12, 13, 15, 16, 17], "skip": [0, 3, 11, 13, 16], "nodoctest": 0, "whole": [0, 10, 12, 14, 15], "neither": [0, 13], "appli": [0, 2, 3, 9, 11, 14], "those": [0, 3, 4, 7, 11], "sloane_databas": 0, "sloaneencyclopedia": 0, "60843": 0, "condit": [0, 12], "met": 0, "internet": [0, 4, 5], "connect": [0, 9, 12, 13, 17], "oei": [0, 15], "a060843": 0, "busi": 0, "beaver": 0, "maxim": [0, 4, 13], "step": [0, 2, 6, 7, 9, 11, 13], "ture": 0, "machin": [0, 4, 5, 6, 11, 13], "tape": 0, "halt": 0, "altern": [0, 2, 4, 5, 7, 9, 11, 12, 13, 14], "alia": [0, 6, 7], "punctuat": 0, "comma": 0, "semicolon": 0, "chomp": 0, "simpli": [0, 3, 5, 9, 11, 13, 15], "insensit": 0, "indirect": 0, "report": [0, 4, 10, 13, 14, 15], "__repr__": [0, 3], "__add__": 0, "intern": [0, 11], "anywher": 0, "32": [0, 1, 2, 4, 7, 9], "bit": [0, 9, 11], "64": [0, 1, 4, 9, 16], "31": [0, 4, 13], "13": [0, 2, 4, 11, 13, 18], "8193": 0, "2147491840": 0, "per": [0, 11, 12, 13, 14], "physic": 0, "77": [0, 11], "grep": [0, 12, 13], "easili": [0, 3, 7, 9, 14], "aforement": 0, "further": [0, 4, 8, 9, 13, 14, 16, 17, 18], "claim": [0, 4, 14], "subsect": 0, "tutori": [0, 10, 15], "remark": 0, "base": [0, 1, 3, 5, 9, 10, 12, 17, 18, 19], "addit": [0, 2, 4, 6, 7, 9, 10, 11, 13, 14, 17], "parallel": [0, 10, 16], "timeout": 0, "recogn": 0, "well": [0, 2, 3, 4, 6, 9, 11, 13], "session": [0, 3, 4], "enter": [0, 7, 9, 13], "thu": [0, 1, 2, 3, 4, 5, 12, 13, 14, 15], "out": [0, 1, 2, 3, 4, 5, 10, 11, 12, 13, 14], "verbatim": 0, "Of": [0, 8, 9, 12], "cours": [0, 3, 8, 9, 10, 12, 13, 17], "linkal": 0, "clariti": 0, "best": [0, 2, 3, 9, 10, 11, 14], "were": [0, 5, 9, 11, 13, 14, 17], "previou": [0, 2, 3, 5, 11, 13], "syntact": 0, "mean": [0, 2, 3, 5, 7, 9, 11, 12, 13], "configur": [0, 3, 4, 7, 10, 11, 12, 13, 16, 17, 19], "emac": [0, 6], "dir": [0, 16], "el": 0, "emacswiki": 0, "deletingwhitespac": 0, "variou": [0, 2, 4, 9, 10, 13, 16, 19], "solut": [0, 2, 7, 11, 12, 14], "id": [0, 4, 10, 13], "globalopt": 0, "decis": [0, 14], "life": 0, "easier": [0, 1, 9, 11], "ascii": [0, 6], "identifi": [0, 12, 13, 14, 15], "\u00e4": 0, "\u00f6": 0, "ae": 0, "oe": 0, "moebius_funct": 0, "m\u00f6biu": 0, "\u00e1": 0, "lovasz_numb": 0, "lov\u00e1sz": 0, "choos": [0, 4, 9, 13, 18], "select": [0, 9, 13, 16], "sensibl": 0, "certif": [0, 13], "boolean": 0, "kind": [0, 1, 11, 12], "With": [0, 3, 4, 16], "pair": [0, 7, 14, 19], "proven": 0, "probabilist": 0, "reli": [0, 11, 12], "prove": 0, "hypothesi": 0, "rh": 0, "paramet": [0, 2], "otherwis": [0, 4, 5, 7, 9, 11, 13, 18], "coerc": [0, 3], "suitabl": [0, 7], "typic": [0, 1, 3, 9, 11, 13], "inplac": 0, "compil": [1, 4, 5, 11, 12, 13, 17], "languag": [1, 2, 10, 15], "python": [1, 2, 4, 7, 10, 12, 13, 14, 16, 17], "The": [1, 4, 5, 6, 7, 8, 10, 12, 13, 16, 18, 19], "advantag": [1, 5], "order": [1, 2, 5, 7, 9, 11, 13, 15, 17], "magnitud": 1, "directli": [1, 5, 6, 7, 11, 14], "essenti": [1, 14], "superset": [1, 13], "doesn": [1, 11, 17], "distinct": [1, 3], "talk": 1, "librari": [1, 3, 10, 11, 13, 14, 16, 17], "convent": [1, 10, 12, 14, 16], "declar": [1, 3, 11, 12, 14], "data": [1, 2, 3, 6, 11], "variabl": [1, 2, 3, 4, 5, 6, 11, 12, 13, 19], "debug": [1, 11, 14], "slow": [1, 2, 4, 5, 12], "effici": [1, 2, 3, 4], "offer": [1, 13], "familiar": [1, 2, 10], "potenti": [1, 7], "greater": 1, "speed": [1, 2, 11, 14, 16], "api": [1, 6], "wa": [1, 3, 4, 5, 9, 10, 11, 13, 14, 17, 18], "origin": [1, 5, 6, 7, 9, 11, 17, 18, 19], "pyrex": 1, "": [1, 2, 3, 5, 6, 7, 8, 9, 10, 11, 12, 14, 15, 16, 17, 18, 19], "concert": 1, "independ": [1, 5, 11], "project": [1, 6, 9, 11, 12, 13, 14, 16, 17], "beyond": [1, 5, 10], "scope": [1, 3, 13], "young": 1, "document": [1, 2, 3, 4, 9, 11, 13, 14, 16, 17], "web": [1, 9, 15, 18], "notebook": [1, 3, 4], "cell": 1, "evalu": [1, 2, 3, 16], "run": [1, 2, 3, 5, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19], "dll": 1, "dylib": 1, "function": [1, 2, 4, 7, 10, 12, 14, 15, 16, 19], "cpdef": 1, "testfunct": 1, "__main__": [1, 4], "complet": [1, 3, 4, 7, 9, 11, 13, 14, 18], "pyx": [1, 2, 3, 4], "rebuild": [1, 9, 10, 11, 13, 14, 15], "easiest": 1, "try": [1, 2, 3, 7, 9, 11, 12, 13, 17], "learn": [1, 6, 10, 13, 14], "about": [1, 2, 3, 4, 6, 9, 10, 11, 13, 14, 16, 17, 18], "distutil": 1, "stand": [1, 11], "power2": 1, "is2pow": 1, "12": [1, 2, 4, 7, 18], "note": [1, 2, 3, 4, 5, 6, 7, 10, 11, 12, 13, 15, 16, 17, 18], "again": [1, 5, 6, 7, 9, 12, 13, 17], "recompil": [1, 17], "fly": 1, "reload": 1, "test": [1, 5, 6, 9, 14, 15, 17], "ghz": 1, "opteron": 1, "16": [1, 3, 4, 12, 13], "128": [1, 4, 13], "256": 1, "512": [1, 13], "1024": 1, "2048": [1, 7], "4096": 1, "8192": 1, "16384": 1, "32768": 1, "65536": 1, "cpu": [1, 4, 9, 16], "60": 1, "sy": [1, 13], "00": [1, 4, 7], "total": [1, 2, 4, 7, 9, 13, 18], "wall": [1, 4], "copi": [1, 3, 4, 5, 7, 9, 10, 11, 13, 15, 17], "powerslow": 1, "py": [1, 2, 3, 4, 5, 7, 11, 12, 15, 16, 17], "04": [1, 4], "05": [1, 4, 13], "By": [1, 4, 7, 11, 12, 13, 16, 17], "gain": 1, "littl": [1, 6, 14], "unsign": 1, "special": [1, 7, 10, 11, 13, 15, 16], "care": [1, 5], "taken": [1, 11], "ctrl": [1, 3, 13], "cysign": 1, "pickl": 1, "__reduce__": 1, "arg": [1, 4, 13], "exampl": [1, 2, 3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 15, 16, 17], "snippet": [1, 4, 7], "cyfunct": 1, "make_integ": 1, "dump": [1, 2], "took": [1, 4], "me": 1, "hour": [1, 4, 13, 16], "pure": [1, 3, 11, 12], "happen": [1, 7, 12, 13, 17, 18], "str": [1, 2], "write": [2, 3, 7, 8, 9, 11, 13, 14, 15, 17, 18], "code": [2, 4, 5, 6, 7, 9, 12, 16, 18, 19], "sage": [2, 6, 7, 14, 16, 18], "structur": [2, 3, 10, 12], "conveni": [2, 4, 6, 12, 13, 17], "fortran": 2, "95": [2, 12], "gp": [2, 13, 19], "sagecompon": 2, "And": [2, 5, 7], "okai": [2, 14], "option": [2, 9, 10, 11, 12, 14, 15, 16], "octav": [2, 4], "magma": [2, 4], "mathematica": [2, 4], "mapl": [2, 4], "frobeniu": 2, "heavi": [2, 12], "lift": 2, "matfrobeniu": 2, "direct": [2, 12], "gen": [2, 4], "abstract": [2, 3, 12], "onc": [2, 4, 9, 10, 12, 13, 14, 17, 18], "receiv": [2, 4, 9, 13, 18], "parierror": 2, "lib": [2, 4, 11, 12, 13, 16], "cypari2": 2, "squar": [2, 4], "divisor": 2, "vector": 2, "sig_on": 2, "new_gen": 2, "statement": [2, 12], "attribut": [2, 3, 10], "apart": 2, "close": [2, 3, 9, 10, 11, 13, 19], "sig_off": 2, "stack": 2, "gone": 2, "new_gen_noclear": 2, "nor": [2, 13], "retriev": 2, "v": [2, 3, 7, 9, 10, 16, 18, 19], "pleas": [2, 3, 9, 11, 12, 14], "mathnf": 2, "matrix_integ": 2, "associ": [2, 5, 11], "saniti": [2, 13], "var": [2, 4, 11, 12, 13], "ration": [2, 3], "canon": 2, "fb": 2, "string": [2, 3, 4, 10, 11], "matrixspac": 2, "18": [2, 4, 11], "is_squar": 2, "arithmeticerror": [2, 4], "__pari__": 2, "matrix_spac": 2, "elif": 2, "base_r": 2, "retr": 2, "append": [2, 11], "eval": [2, 4], "gens_dict": 2, "nrow": 2, "matter": [2, 3, 5, 10, 11, 12, 13], "pexpect": 2, "pipe": 2, "back": [2, 5, 10, 11, 14, 17, 18], "hard": [2, 5, 7, 11, 12], "suppos": [2, 3, 4, 5, 18], "wrapper": [2, 11, 15], "cartan": 2, "simpl": [2, 7, 9], "lie": 2, "g_2": 2, "simpleliealgebra": 2, "dimens": 2, "14": [2, 4, 11, 13], "rootsystem": 2, "root": [2, 11, 13], "cartanmatrix": 2, "11": [2, 3, 4, 7, 9, 12, 13], "directori": [2, 3, 4, 5, 6, 7, 10, 13, 15, 17], "legal": 2, "cartan_matrix": 2, "chevallei": 2, "sm": 2, "guava": 2, "finit": [2, 12], "permut": 2, "left": [2, 3, 7, 13], "exercis": 2, "few": [2, 3, 4, 9, 11, 12, 14, 16, 18], "idea": [2, 9, 12, 17], "freeliealgebra": 2, "gener": [2, 3, 4, 9, 10, 11, 12, 14, 15, 16, 17, 19], "freegroup": 2, "tabl": 2, "though": [2, 5, 11, 12, 14], "disadvantag": 2, "other": [2, 3, 4, 6, 7, 9, 10, 11, 13, 14, 15, 16, 17], "certain": [2, 3, 5, 11, 13], "unavoid": [2, 7], "latenc": 2, "10m": 2, "send": [2, 13], "lower": [2, 11], "furthermor": 2, "why": [2, 4, 11, 14], "kernel": [2, 12, 13], "analogu": 2, "function_factori": 2, "conceptu": 2, "terminologi": 2, "equat": 2, "degre": 2, "d": [2, 4, 5, 6, 7, 11, 13], "galoi": 2, "orbit": 2, "point": [2, 3, 5, 9, 10, 11, 12, 13, 14, 16], "nsplace": 2, "closed_point": 2, "carri": 2, "greuel": 2, "pfister": 2, "schoenemann": 2, "mathematik": 2, "der": 2, "universitaet": 2, "67653": 2, "kaiserslautern": 2, "brnoeth": 2, "lp": 2, "poli": 2, "x1": 2, "adj_div": 2, "affin": 2, "infin": 2, "adjunct": 2, "genu": 2, "x2": 2, "x3": 2, "extcurv": 2, "setr": 2, "calcul": [2, 18], "global": [2, 3, 4, 6, 8, 10, 12, 13, 15, 17], "coeffici": [2, 3], "block": [2, 3, 4, 15, 16], "notic": [2, 3, 4, 12, 13], "coordin": 2, "manipul": 2, "points_pars": 2, "string_point": 2, "entri": [2, 3, 16], "pt": [2, 16], "len": [2, 4], "l1": [2, 13], "idx": 2, "block1": 2, "idx2": 2, "l2": 2, "repeat": [2, 9, 12, 17], "block2": 2, "block3": 2, "ingredi": 2, "tripl": 2, "moment": 2, "ourselv": 2, "places_on_curv": 2, "docstr": [2, 3, 11, 16], "mpolynomialr": 2, "simpler": 2, "set_r": 2, "compar": [2, 3, 12], "breviti": 2, "omit": [2, 3, 4, 11], "point_pars": 2, "notimplementederror": 2, "nice": [2, 6, 9, 17], "wherea": 2, "barest": 2, "minimum": [2, 4, 11], "modif": [2, 3, 11, 17], "surprisingli": 2, "fast": [2, 3, 4, 10, 12, 18], "flexibl": 2, "becaus": [2, 3, 4, 5, 7, 11, 12, 13, 14, 16, 17], "buffer": 2, "asynchron": 2, "deriv": [2, 3, 13, 18], "file": [2, 3, 5, 6, 7, 8, 9, 10, 12, 13, 14, 16, 17, 18], "open": [2, 3, 5, 10, 11, 13, 14, 15, 17, 18], "among": [2, 3, 9, 13], "thing": [2, 3, 4, 6, 7, 10, 12, 14, 15], "expectel": 2, "routin": 2, "come": [2, 6, 11, 12, 13], "script_subdirectori": 2, "logfil": [2, 4], "server": [2, 7, 10, 13, 19], "server_tmpdir": 2, "silent": [2, 13], "restart_on_ctrlc": 2, "verbose_start": 2, "eval_using_file_cutoff": 2, "100": [2, 3, 7, 9, 18], "cmd": 2, "ncode": 2, "noctav": 2, "octave_consol": 2, "solve_linear_system": 2, "mxn": 2, "resp": 2, "solv": [2, 4, 7, 9, 14], "m33": 2, "v3": 2, "vectorspac": 2, "333333": 2, "666667": 2, "david": 2, "joyner": 2, "william": 2, "stein": 2, "ncol": 2, "valueerror": 2, "column": 2, "sa": [2, 13], "sage2octave_matrix_str": 2, "sb": 2, "soln": [2, 4], "sol": 2, "excerpt": 2, "advic": [3, 5, 14], "regard": [3, 10, 11, 12], "oldest": 3, "introduc": [3, 7, 14], "cannot": [3, 5, 11, 12, 13, 14], "newer": [3, 11, 13], "failur": [3, 12, 13], "doctest": [3, 5, 9, 10, 11, 13, 14, 15, 17], "backport": 3, "mechan": [3, 12, 13], "__future__": 3, "annot": [3, 12, 13], "modern": [3, 12], "accord": [3, 9, 11, 12], "563": 3, "postpon": 3, "importlib_metadata": 3, "importlib": 3, "importlib_resourc": 3, "typing_extens": 3, "meta": [3, 19], "29756": 3, "keep": [3, 5, 7, 11, 12, 13, 16, 19], "serv": [3, 11, 12], "plan": [3, 10, 16], "think": [3, 9, 14, 17], "fit": [3, 15, 17], "orient": 3, "hierarchi": [3, 10, 11, 13], "organ": [3, 5, 7, 9, 12], "ringel": 3, "scratch": [3, 4, 13, 17], "accordingli": [3, 10], "__xxx__": 3, "predefin": 3, "_xxx_": 3, "semi": 3, "privat": [3, 7, 19], "realli": [3, 4, 5, 6, 11, 17], "sage_object": 3, "myclass": 3, "myfavoritealgebra": 3, "_latex_": 3, "_repr_": 3, "natur": [3, 5], "accur": [3, 9], "displai": [3, 7, 11, 16, 17], "typeset": 3, "correctli": [3, 11, 13], "built": [3, 9, 10, 11, 12, 15, 16, 17], "deal": [3, 7, 9, 12, 14], "forget": [3, 13, 17], "amsmath": 3, "amssymb": 3, "amsfont": 3, "commontex": 3, "tex": [3, 16], "templat": [3, 11, 18], "fake": 3, "denom": 3, "produc": [3, 4, 5, 9, 11], "view": [3, 9, 13], "renam": [3, 11], "context": [3, 9, 13], "symbol": [3, 12, 13], "constant": 3, "ratio": 3, "circl": 3, "circumfer": 3, "diamet": 3, "1415926535897931": 3, "_matrix_": 3, "generic_graph": 3, "genericgraph": 3, "am": [3, 13], "change_r": 3, "adjacency_matrix": 3, "spars": 3, "boundary_first": 3, "similarli": 3, "_vector_": 3, "free_module_el": 3, "cdef": [3, 15], "freemoduleel": 3, "element_vector": 3, "usabl": [3, 11, 12], "tweak": 3, "commandlin": 3, "technic": [3, 6, 10], "rewrit": [3, 7, 10, 14], "notabl": 3, "_first_ngen": 3, "sqrt": 3, "87": 3, "29": [3, 4, 12, 13], "raw": 3, "denot": 3, "393939r": 3, "393939": 3, "gmp": [3, 14], "consult": 3, "load": [3, 4, 10, 11, 12], "attach": [3, 10], "autogener": [3, 4], "repl": [3, 12], "primari": 3, "transpar": 3, "comparison": [3, 11], "perform": [3, 4, 5, 9, 12, 16], "operand": 3, "despit": 3, "obviou": 3, "facilit": [3, 13], "map": [3, 12], "domain": [3, 12], "strict": 3, "resolv": [3, 7, 9, 18], "ambigu": [3, 16], "nonsens": 3, "immut": 3, "uniqu": [3, 5, 11, 15], "label": [3, 9, 11, 14], "precis": [3, 9], "wast": 3, "memori": [3, 4, 11, 12, 13], "weakref": 3, "becom": [3, 11, 12, 13], "member": 3, "collect": [3, 19], "frozenset": 3, "advis": [3, 16], "mix": [3, 16], "plai": [3, 12], "pack": [3, 7, 9, 18], "__eq__": 3, "hashabl": 3, "wrong": [3, 4, 7, 9, 17], "bucket": 3, "datamodel": 3, "phrase": [3, 9], "violat": [3, 16], "consequ": [3, 7], "fortun": [3, 7, 12], "pretti": [3, 6], "clearli": [3, 7, 14], "understand": [3, 14], "caus": [3, 4, 9, 14], "troubl": 3, "w": [3, 7], "keyerror": 3, "realfield": 3, "10000": 3, "rdf": 3, "unfortun": 3, "seriou": 3, "forc": [3, 4, 11, 13], "fix": [3, 4, 5, 6, 7, 9, 10, 11, 12, 13, 14, 16, 18], "abandon": [3, 5], "unread": 3, "unwrit": 3, "live": 3, "attempt": [3, 4, 7, 8, 11, 13], "satisfi": [3, 17, 18], "judgment": 3, "overboard": 3, "moduli": 3, "catch": 3, "some_cod": [3, 5], "bad": 3, "more_cod": 3, "typo": [3, 10, 14], "alarm": 3, "propag": 3, "summar": [3, 11], "__coordinate_r": 3, "attributeerror": 3, "otherexcept": 3, "msg": 3, "more_code_to_compute_someth": 3, "caught": 3, "explor": 3, "theoret": 3, "__len__": 3, "__int__": 3, "ineg": 3, "circular": 3, "parti": [3, 7, 10, 17], "viewpoint": [3, 12], "steenrod_algebra_bas": 3, "steenrodalgebra": 3, "importerror": [3, 4, 12], "polynomial_el": 3, "polynomial_generic_dens": 3, "__normal": 3, "ignor": [3, 11, 13, 14, 16, 17], "steenrod_algebra_basi": 3, "_basis_nam": 3, "matplotlib": [3, 11], "domin": 3, "control": [3, 4, 6, 7, 10, 11, 12, 13, 17], "lazi": [3, 12], "actual": [3, 8, 11, 12], "delai": [3, 14], "precomput": 3, "decor": 3, "cachefunc": 3, "cached_funct": 3, "big_data": 3, "initialize_big_data": 3, "backward": 3, "incompat": [3, 11], "stabl": [3, 11, 12, 13, 14, 16, 17], "666": 3, "rename_keyword": 3, "my_funct": 3, "my_old_keyword": 3, "my_new_keyword": 3, "deprecated_function_alia": 3, "supersed": [3, 12], "my_new_funct": 3, "my_old_funct": 3, "move": [3, 5, 7, 10, 11, 16], "name_of_the_funct": 3, "lazili": 3, "func1": [3, 15], "func2": 3, "explicit": [3, 4, 9, 15], "visibl": [3, 17], "_lazy_import": 3, "some_funct": 3, "properli": [3, 9, 14], "brain": 3, "newli": 3, "stuff": 3, "earli": 3, "worri": [3, 17], "delet": [3, 5, 7, 11, 12, 13, 17], "fulli": [3, 11, 19], "review": [3, 7, 9, 10, 11, 16, 18], "66666": 3, "experimental_funct": 3, "experimental_class": 3, "experimental_warn": 3, "foolproof": 3, "gracefulli": 3, "perhap": [3, 5, 14], "hint": [3, 12, 13], "optional_packag": 3, "thread": [4, 18], "jdemey": 4, "pwd": [4, 13], "autom": [4, 9, 10, 11, 13, 15, 19], "sudoku": 4, "game": 4, "window": [4, 8, 13], "cd": [4, 5, 9, 11, 12, 13, 17], "2012": 4, "07": [4, 11, 13], "36": 4, "49": 4, "d82849c6": 4, "103": [4, 13], "cumul": 4, "amount": 4, "surpris": 4, "approxim": 4, "39": 4, "02": [4, 11], "da6accbb": 4, "40": [4, 5, 7], "53": 4, "6cc4f29f": 4, "hexad": 4, "sudoku_backtrack": 4, "quantumino": 4, "41": [4, 13], "95ebd2ff": 4, "wide": [4, 11, 13], "recip": [4, 13], "tox": [4, 10, 11], "dot": [4, 12], "forward": [4, 18], "slash": 4, "precaut": 4, "against": [4, 11, 13, 16], "aris": 4, "43": 4, "24": [4, 12, 13], "a3449f54": 4, "54": 4, "ac8ca007": 4, "home": [4, 6, 7], "515": 4, "backtrack": 4, "usr": [4, 11, 13], "ncadoctest": 4, "1231": 4, "run_one_test": 4, "run_one_exampl": 4, "compileflag": 4, "sagedoctest": 4, "38": [4, 7, 11], "origdoctestrunn": 4, "1172": 4, "glob": 4, "example_13": 4, "tmp": [4, 13, 16], "607": 4, "719": 4, "backtrack_al": 4, "had": [4, 7, 10, 12], "15": [4, 12, 13], "example_14": 4, "whitespac": [4, 10, 16], "doctest_sudoku": 4, "older": [4, 12, 17], "far": [4, 5], "hundr": 4, "thousand": 4, "hardwar": 4, "six": 4, "multi": [4, 11, 13], "core": [4, 6, 8, 12, 13], "significantli": 4, "devot": 4, "crypto": 4, "achiev": [4, 7, 14], "45": [4, 6, 13], "7f837dcf": 4, "boolean_funct": 4, "252": 4, "cipher": 4, "classic": 4, "718": 4, "classical_ciph": 4, "130": 4, "82": 4, "lfsr": 4, "stream": 4, "17": [4, 13, 16], "stream_ciph": 4, "114": [4, 13], "util": [4, 10, 12], "122": [4, 12], "block_ciph": 4, "minia": 4, "430": 4, "sde": 4, "290": 4, "mq": 4, "mpolynomialsystem": 4, "320": 4, "mpolynomialsystemgener": 4, "sbox": 4, "124": 4, "sr": [4, 12], "435": [4, 13], "public_kei": 4, "blum_goldwass": 4, "135": [4, 16], "35": [4, 6, 13], "48": [4, 6, 13], "c16721e6": 4, "437": 4, "111": [4, 12], "106": 4, "108": 4, "five": 4, "test_consist": 4, "max_n": 4, "kwarg": 4, "encrypt": 4, "round": [4, 14], "ram": [4, 13], "2gb": 4, "2011": [4, 11], "tp": [4, 12, 15], "55": 4, "9b17765e": 4, "slower": [4, 14], "429": 4, "432": 4, "123": 4, "289": 4, "113": [4, 13], "134": 4, "121": 4, "79": 4, "318": 4, "717": 4, "d71f3cd4": 4, "434": 4, "88": [4, 7], "90": 4, "increas": [4, 11], "decreas": 4, "resid": 4, "ptestlong": [4, 14], "j12": 4, "multiprocess": 4, "cpu_count": 4, "clone": [4, 6, 9, 17], "testlong": 4, "ptest": [4, 13], "fr": [4, 15, 16], "final": [4, 5, 10, 11, 13, 14, 18], "fine": [4, 5, 9, 11], "my_python_script": 4, "mvngu": 4, "cat": [4, 11, 13], "all_cmdlin": 4, "56": [4, 7], "d056f7c0": 4, "my_sage_script": 4, "content": [4, 5, 6, 7, 11, 15, 17], "cube": 4, "20": [4, 5, 11, 13, 14], "06": 4, "82ee728c": 4, "_sage_const_3": 4, "26": [4, 13], "46": [4, 6, 13], "2bb00911": 4, "wait": [4, 19], "run_doctest": 4, "combinat": [4, 12, 15], "affine_permut": 4, "2018": [4, 13], "23": [4, 11, 13], "89fe17b1": 4, "branch": [4, 6, 7, 9, 10, 11, 13, 14, 16], "sagemath_doc_html": [4, 11], "opt": [4, 13], "sage_st": 4, "338": 4, "ideal": [4, 5, 11], "my_long_test": 4, "off": [4, 5, 14], "capabl": 4, "sooner": 4, "hurt": 4, "abil": 4, "normal": [4, 7, 12, 16, 19], "spent": [4, 11], "ro": 4, "40835825": 4, "d13a9a24": 4, "34": [4, 13], "factorint": 4, "27": [4, 13], "2c952ac1": 4, "125": 4, "base_expon": 4, "ran": [4, 14], "09": [4, 9, 11, 13], "153": 4, "factor_aurifeuillian": 4, "fa": 4, "22": [4, 7, 9, 13], "155": 4, "58": [4, 12, 13], "163": [4, 16], "c9164c9d": 4, "240": 4, "test_random_el": 4, "trial": 4, "1000": 4, "283": 4, "test_random_arith": 4, "seed": [4, 7], "kliem": 4, "random_se": 4, "2020": 4, "59": [4, 11], "49f37a55": 4, "112986622569797306072457879734474628454": 4, "randint": 4, "got": [4, 7, 11, 17], "reproduc": [4, 9, 13], "28": [4, 13], "14a52269": 4, "sage_doctest_random_se": 4, "obvious": [4, 17], "succe": [4, 13], "download": [4, 5, 7, 11, 13, 14, 17, 18], "equival": [4, 11, 15, 16], "real_mpfr": 4, "a368a200": 4, "819": 4, "a00a7319": 4, "823": 4, "33": [4, 5], "a2bc1fdf": 4, "detect": [4, 11, 14], "latex": [4, 16], "2016": [4, 13], "af2ebb67": 4, "cplex": 4, "gurobi": 4, "macaulay2": 4, "matlab": 4, "scilab": 4, "regardless": 4, "8c097f55": 4, "865": 4, "re": [4, 5, 11, 13], "big": [4, 14], "speedup": [4, 14], "nthread": 4, "19": [4, 11, 13], "a3afdb8c": 4, "187": 4, "forker": 4, "322": 4, "e26fce6d": 4, "entir": [4, 5, 12, 13, 16], "304": 4, "69": [4, 13], "drop": [4, 13], "debugg": 4, "scheme": [4, 12], "elliptic_curv": 4, "b6352629": 4, "python2": 4, "site": [4, 12], "573": 4, "_run": 4, "835": 4, "exec": [4, 5, 11], "346": 4, "ell_rational_field": 4, "ellipticcurve_rational_field": 4, "216": 4, "ellipticcurve_number_field": 4, "ainv": 4, "ell_number_field": 4, "159": 4, "ellipticcurve_field": 4, "ell_gener": 4, "156": 4, "invari": 4, "pdb": 4, "151": 4, "152": 4, "__ainv": 4, "154": 4, "discrimin": 4, "157": 4, "pp": 4, "projective_spac": 4, "projectivespac": 4, "xyz": 4, "158": [4, 12], "coordinate_r": 4, "a1": 4, "a2": 4, "a3": 4, "a4": 4, "a6": 4, "160": 4, "161": 4, "quit": [4, 5, 6, 9, 12, 13], "segfault": 4, "hang": 4, "gdb": 4, "venv": [4, 11, 12, 13], "runtest": 4, "serial": 4, "stats_path": 4, "timings2": 4, "json": [4, 12, 13, 16], "pip": [4, 11, 12, 13, 16], "sage_spkg": [4, 13], "debian": [4, 8, 11, 13], "2008": 4, "inc": 4, "gplv3": [4, 11], "gpl": 4, "NO": 4, "warranti": 4, "extent": [4, 13], "permit": 4, "law": 4, "x86_64": [4, 13], "linux": [4, 8, 9, 11, 13], "libthread_db": 4, "enabl": [4, 11, 12, 13, 15], "0x7f10f85566e0": 4, "lwp": 4, "6534": 4, "b1b735e7": 4, "67": 4, "exit": [4, 11, 13, 16], "valgrind": 4, "memcheck": 4, "massif": 4, "cachegrind": 4, "omega": 4, "wiki": 4, "valgrindingsag": 4, "whatev": [4, 15], "reveal": 4, "rerun": [4, 11, 13], "d8b5a408": 4, "behavior": [4, 9, 13], "cascad": 4, "nameerror": 4, "weren": 4, "finite_r": [4, 12], "integer_mod": 4, "8136f5e3": 4, "axiom": 4, "cunningham": 4, "frica": 4, "440": [4, 12], "intermitt": 4, "repeatedli": 4, "heisenbug": 4, "sandpil": 4, "e7048ad9": 4, "711": 4, "proceed": [4, 18], "8f954206": 4, "1422": 4, "averag": 4, "finish": [4, 5, 10, 12, 13, 17], "proce": [4, 9, 14], "minut": [4, 6, 13], "slowest": 4, "37": [4, 12], "deb1ab83": 4, "2067": 4, "abspath": 4, "a023e212": 4, "133": 4, "commit": [4, 5, 6, 7, 10, 11, 14, 18], "52": [4, 9, 12, 16], "645620ee": 4, "subtl": 4, "randord": 4, "127": 4, "97c8484e": 4, "test1": 4, "e7c0e52d": 4, "statist": 4, "stat": [4, 6], "2df4251d": 4, "cover": [5, 14], "walk": [5, 9, 10, 18], "snapshot": [5, 13, 17], "But": [5, 12], "secretli": 5, "alic": [5, 6, 7, 8, 9, 11, 17, 18], "localhost": [5, 6, 7, 8, 9, 11, 17, 18], "checkout": [5, 6, 7, 11, 17, 18], "f9a0d54099d758ccec731a38929902b2b9d0b988": 5, "switch": [5, 7, 13, 17, 18], "around": [5, 10, 12, 14, 15, 16], "experiment": [5, 11, 13], "discard": [5, 17], "impact": [5, 17], "retain": 5, "Or": [5, 6, 9, 11], "undo": 5, "config": [5, 6, 7, 8, 9, 11, 13, 17], "detachedhead": 5, "f9a0d54099": 5, "matrix_integer_dense_hnf": 5, "repo": [5, 7, 9, 16, 17, 18], "fetch": [5, 7, 9, 13, 18], "com": [5, 6, 7, 8, 9, 13, 15, 16, 17, 18], "fetch_head": [5, 7], "noth": [5, 17], "clean": [5, 6, 13, 16], "perfectli": 5, "my_branch": [5, 7, 17], "ticket": [5, 13, 14, 16], "touch": 5, "beta": [5, 13, 14], "partial": [5, 13], "ag": 5, "timestamp": [5, 17], "renew": 5, "bring": [5, 14], "onto": 5, "trigger": [5, 11, 13, 14, 17], "unnecessari": [5, 11], "new_worktre": 5, "worktre": [5, 13, 16], "safe": [5, 7, 12], "rm": [5, 11, 12], "Being": 5, "unpleas": 5, "pursu": 5, "truli": 5, "mess": 5, "feet": 5, "hexadecim": 5, "sha1": [5, 7], "revert": 5, "eafaedad5b0ae2013f8ae1091d2f1df58b72bae3": 5, "sat": 5, "jul": 5, "57": 5, "0400": 5, "eafa": 5, "uncommit": 5, "coupl": 5, "hex": [5, 7], "complain": 5, "th": [5, 7], "ultim": 5, "human": [5, 7], "tool": [5, 6, 8, 9, 10, 12, 17, 19], "reflog": 5, "chronolog": [5, 17], "assum": [5, 7, 8, 9, 11, 13, 17], "went": [5, 9, 11], "shot": 5, "myself": 5, "my": [5, 6, 13], "foot": 5, "2eca2a2": 5, "b4d86b9": 5, "af353bb": 5, "some_branch": 5, "master": [5, 6, 7, 17], "1142feb": 5, "other_branch": 5, "revis": [5, 6, 7, 10, 11, 13, 17], "rewind": 5, "erron": 5, "thoroughli": 5, "screw": 5, "yet": [5, 7, 9, 11, 13, 14, 17], "push": [5, 6, 9, 10, 11, 13, 14, 17, 18, 19], "simplic": 5, "ll": 5, "file_a": 5, "file_b": 5, "file_c": 5, "onelin": [5, 7], "9621dae": 5, "7873447": 5, "bf817a5": 5, "5b5588e": 5, "ought": 5, "second_branch": 5, "new_branch_nam": 5, "first_branch": 5, "cherri": 5, "pick": [5, 9, 11], "758522b": 5, "100644": [5, 17], "exclud": [5, 12], "5844535": 5, "voila": 5, "approach": [5, 10], "children": 5, "instuct": 5, "reword": 5, "stop": [5, 13], "amend": 5, "squash": 5, "meld": [5, 7], "fixup": 5, "rest": [5, 9, 12, 15], "bottom": [5, 13], "THAT": 5, "WILL": 5, "BE": 5, "abort": 5, "materi": 6, "minim": [6, 9, 13, 16, 17], "gitconfig": [6, 8], "adventur": [6, 8, 17], "wonderland": [6, 8, 17], "vim": 6, "diff": [6, 7, 11, 14, 17], "color": 6, "wdiff": 6, "ci": [6, 13], "st": 6, "br": [6, 17], "enforc": 6, "lg": 6, "cred": 6, "creset": 6, "yellow": [6, 13], "cgreen": 6, "cr": 6, "blue": 6, "abbrev": 6, "changelog": [6, 11, 13], "6d8e1e": 6, "head": [6, 7, 10, 13, 17, 18], "nf": 6, "ago": [6, 13], "matthew": 6, "brett": 6, "d304a73": 6, "placehold": 6, "pull": [6, 7, 10, 12, 13, 14, 17, 18], "hhuuggoo": 6, "week": [6, 14], "jonathan": 6, "terhorst": 6, "4aff2a8": 6, "test_bugfix": 6, "hugo": 6, "a7ff2e5": 6, "propos": [6, 10, 11], "dure": [6, 7, 11, 12, 13], "arrai": 6, "summit": 6, "corran": 6, "webster": 6, "68f6752": 6, "axisindex": 6, "index_bi": 6, "ax": 6, "sketchi": 6, "corr": 6, "376adbd": 6, "b605216": 6, "joshu": 6, "2e991e8": 6, "outer": 6, "ufunc": 6, "7beda5a": 6, "axi": 6, "throw": 6, "65af65": 6, "unit": 6, "assert": 6, "956fbab": 6, "remot": [6, 9, 10, 13, 17, 18, 19], "gittutori": 6, "introductori": 6, "extend": [6, 12], "intermedi": [6, 13], "parabl": 6, "concept": [6, 7, 17], "behind": [6, 12], "although": 6, "detach": [6, 10], "visual": [6, 13, 15, 16, 17], "excel": 6, "seri": 6, "pro": [6, 7], "depth": [6, 10], "train": 6, "kit": 6, "video": 6, "screencast": 6, "readi": [6, 9, 13, 14, 18], "post": [6, 9, 12, 14], "thumb": 6, "linu": 6, "torvald": 6, "workflow": [6, 9, 10, 11, 13, 19], "activ": [6, 12, 16], "exchang": 7, "notion": [7, 11, 12, 14], "central": [7, 9], "throughout": [7, 17], "secur": [7, 19], "cryptographi": 7, "cryptograph": 7, "protocol": [7, 9], "inspect": [7, 9, 13, 17], "keygen": [7, 19], "brief": [7, 10], "rsa": 7, "id_rsa": 7, "passphras": 7, "identif": 7, "pub": 7, "fingerprint": 7, "ce": 7, "b3": 7, "c9": 7, "f0": 7, "f2": 7, "1c": 7, "0a": 7, "randomart": 7, "ob": 7, "folder": [7, 13, 15], "hand": [7, 11, 13, 16, 17], "anybodi": [7, 14], "disclos": 7, "trust": 7, "administr": 7, "leav": [7, 13, 18], "login": [7, 9, 13], "intervent": 7, "procedur": [7, 9, 10, 13, 14, 15, 18, 19], "account": [7, 10, 11, 14, 19], "bookmark": 7, "12345": [7, 14, 18], "count": [7, 9, 16, 18], "compress": [7, 9, 11, 18], "delta": [7, 9, 18], "reus": [7, 9, 13, 17, 18], "unpack": [7, 11, 18], "kib": [7, 18], "206": 7, "temporarili": 7, "databas": [7, 11], "filesystem": [7, 13], "task": [7, 11, 12], "synchron": [7, 12], "bob": [7, 18], "incorpor": [7, 11], "hi": 7, "35608": 7, "ort": 7, "strategi": [7, 12, 13], "inv": [7, 16], "98082": 7, "131309": 7, "byte": 7, "sh": [7, 12, 13], "stai": [7, 11], "accident": [7, 9], "notifi": 7, "ff": 7, "trivial": [7, 9], "reset": [7, 10, 17], "advanc": [7, 9, 10, 13, 16], "principl": 7, "replai": 7, "atop": 7, "somebodi": [7, 14], "began": 7, "collabor": [7, 13], "con": 7, "risk": [7, 10, 14], "laptop": 7, "mergetool": 7, "opendiff": 7, "kdiff3": 7, "araxi": 7, "bc3": 7, "codecompar": 7, "emerg": 7, "vimdiff": 7, "fibonacci": 7, "favourit": 7, "cross": 7, "platform": [7, 8, 9, 10, 11, 16], "screenshot": 7, "middl": 7, "click": [7, 9, 13, 14, 15], "arrow": [7, 12], "adjac": 7, "pane": [7, 13], "overlap": 7, "hypothet": [7, 11], "he": [7, 14, 18], "perfect": [7, 14], "certainli": 7, "meanwhil": 7, "recurs": [7, 11], "her": [7, 18], "latest": [7, 10, 11, 13, 16, 17], "41675dfaedbfb89dcff0a47e520be4aa2b6c5d1b": 7, "half": 7, "job": [7, 13, 14], "reconcil": 7, "upload": [7, 9, 10, 11, 12], "mine": 7, "6316447": 7, "41675df": 7, "14ae1d3": 7, "14afe53": 7, "ubuntu": [8, 9, 13], "sudo": [8, 11, 13], "apt": [8, 9, 13], "fedora": [8, 13], "yum": [8, 13], "cygwin": [8, 11, 13], "nativ": [8, 9, 11, 12], "wsl": [8, 13], "pitfal": 8, "maco": [8, 9, 11, 17], "xcode": [8, 13], "homepag": 8, "address": [8, 14], "center": [9, 10, 12], "usernam": [9, 13], "gh": [9, 18], "github_cli": 9, "authent": [9, 10], "auth": 9, "credenti": 9, "ye": [9, 11, 12, 13, 14], "browser": [9, 15], "3da8": 9, "5ada": 9, "press": [9, 13], "git_protocol": 9, "token": [9, 13], "readm": [9, 12, 13, 17], "ssh": [9, 10, 19], "dialogu": 9, "popular": [9, 13, 16], "cach": [9, 12, 13, 16, 17], "keypair": 9, "visit": [9, 13], "afresh": 9, "914565": 9, "2738": 9, "855": 9, "1950": 9, "2493": 9, "1875": 9, "911827": 9, "331": 9, "mib": [9, 18], "725438": 9, "9936": 9, "1136": 9, "1084": 9, "308": 9, "825": 9, "982": 9, "776": 9, "62": [9, 16], "838": 9, "145": 9, "establish": 9, "googl": [9, 11], "devel": [9, 11, 13], "anyon": [9, 17], "buggi": [9, 14], "architectur": 9, "thank": [9, 13], "seem": [9, 11, 12, 13], "nobodi": 9, "broad": 9, "inde": [9, 10], "problemat": [9, 14], "Be": [9, 14], "titl": [9, 11, 18], "solvabl": 9, "silli": 9, "world": [9, 14], "metric": [9, 14], "background": [9, 13], "convers": 9, "scan": 9, "concis": [9, 14, 17], "attent": [9, 10], "expertis": 9, "refactor": [9, 14], "linear": 9, "geometri": 9, "minor": [9, 10], "blocker": [9, 14], "wishlist": 9, "prepar": [9, 10, 11, 14, 16], "said": 9, "duplic": [9, 11, 14, 15], "understood": 9, "draft": [9, 18], "soon": [9, 12], "peer": [9, 14], "info": [9, 14, 16], "answer": [9, 14], "merg": [9, 10, 11, 12, 14], "resolut": [9, 14, 18], "invalid": [9, 10], "wontfix": [9, 14], "worksform": [9, 14], "12699": 9, "unreli": 9, "issue_num": 9, "crash": [9, 14], "submit": [9, 11, 18], "hero": 9, "lint": [9, 10], "style": [9, 10, 14, 16], "guidelin": [9, 10, 14], "pycodestyl": [9, 10], "relint": [9, 10, 12], "increment": [9, 12, 13], "focal": [9, 13], "dispatch": 9, "prebuilt": [9, 12, 13], "yourself": [9, 11], "examin": [9, 18], "stale": 9, "regularli": 9, "triag": 9, "classifi": 9, "perceiv": 9, "2023": [10, 14], "trac": [10, 13, 14], "transit": 10, "legaci": [10, 11], "aspect": [10, 14], "upgrad": [10, 11, 13], "tell": [10, 17], "globe": 10, "pai": 10, "prerequisit": [10, 17], "gitpod": 10, "onlin": [10, 19], "launch": 10, "pre": [10, 11, 16, 19], "workspac": [10, 13], "straight": 10, "awai": 10, "enhanc": 10, "progress": 10, "todai": 10, "tricki": 10, "evolv": 10, "experienc": [10, 14], "contributor": 10, "highest": 10, "deep": 10, "compos": [10, 13], "luck": 10, "cli": 10, "fork": [10, 11, 13, 17, 18], "stopgap": 10, "glanc": 10, "rebas": [10, 11, 13, 16], "recoveri": [10, 17], "practic": [10, 11], "past": [10, 13, 15], "miscellan": 10, "troubleshoot": 10, "buildbot": 10, "docker": 10, "ghcr": 10, "io": [10, 11], "startuptim": 10, "codespel": 10, "pyright": 10, "pyflak": 10, "highlight": [10, 13], "coercion": [10, 14], "model": 10, "mutabl": 10, "__hash__": 10, "deprec": [10, 12], "spyx": 10, "interrupt": 10, "signal": 10, "unpickl": 10, "extern": [10, 12, 13, 14, 15], "gap": [10, 14], "libgap": 10, "pseudo": 10, "tty": 10, "creativ": 10, "alik": 10, "motto": 11, "reinvent": 11, "wheel": [11, 12], "bash": [11, 13], "invok": [11, 16], "suit": 11, "overrid": 11, "sage_check": 11, "sage_check_packag": 11, "Not": [11, 12], "divid": 11, "stringent": 11, "bar": 11, "orthogon": 11, "divis": 11, "ini": [11, 12, 13, 16], "host": 11, "mirror": [11, 13], "record": [11, 17], "sage_loc": [11, 12, 13], "polici": 11, "whl": [11, 12], "pypi": [11, 12, 16], "simplest": 11, "pypa": 11, "user_guid": 11, "deleg": 11, "dummi": [11, 13], "regener": 11, "auto": [11, 16], "addition": [11, 13, 15], "unmodifi": 11, "alphanumer": 11, "ffla": 11, "ffpack": 11, "fflas_ffpack": [11, 13], "tar": [11, 13, 16], "gz": [11, 13, 16], "distro": [11, 13], "platform1": 11, "platform2": 11, "has_nonfree_depend": 11, "huge": [11, 14], "baz": 11, "shebang": 11, "permiss": 11, "boilerpl": 11, "focu": [11, 14, 16], "respons": 11, "templatess": 11, "preinst": 11, "postinst": 11, "24106": 11, "necessarili": [11, 13], "sdh_configur": 11, "sdh_make": 11, "sdh_make_instal": 11, "sage_spkg_install_doc": 11, "sdh_instal": 11, "sage_shar": 11, "package_nam": 11, "fi": 11, "cflag": 11, "cxxflag": 11, "fcflag": 11, "f77flag": 11, "o2": 11, "march": 11, "fat": 11, "slightli": [11, 13], "export": [11, 13], "cflags_non_n": 11, "o3": 11, "cflags_o3": 11, "possibli": [11, 13], "original_cflag": 11, "likewis": [11, 13], "prior": 11, "23179": 11, "deliber": 11, "bootstrap": [11, 12, 13], "sage_sudo": 11, "observ": 11, "Such": [11, 12], "dist": [11, 16], "sdh_": 11, "sdh_die": 11, "stdin": 11, "conjunct": 11, "heredoc": 11, "_eof_": 11, "sdh_check_var": 11, "undefin": 11, "unwant": 11, "expans": 11, "libdir": 11, "static": [11, 16], "target": [11, 13, 15], "destdir": 11, "stage": [11, 13, 14, 17], "sage_destdir": 11, "sdh_setup_bdist_wheel": 11, "bdist_wheel": 11, "sdh_pip_instal": 11, "sdh_store_and_pip_install_wheel": 11, "sdh_pip_editable_instal": 11, "concern": 11, "sdh_pip_uninstal": 11, "uninstal": 11, "unsuccess": [11, 12], "sage_spkg_wheel": 11, "dest": 11, "destin": 11, "prepend": 11, "treat": 11, "sdh_guard": 11, "won": 11, "unintend": 11, "sdh_cmake": 11, "cmake": [11, 13], "gnuinstalldir": 11, "cmake_install_prefix": 11, "cmake_install_libdir": 11, "sdh_preload_lib": 11, "sonam": 11, "op": 11, "ld_preload": 11, "24885": 11, "processor": [11, 12], "arch": [11, 13], "conda": [11, 17], "homebrew": 11, "brew": [11, 13], "popul": [11, 12], "suitespars": 11, "scipi": [11, 12], "python_toolchain": 11, "fundament": [11, 12], "setuptool": [11, 12], "encod": 11, "constraint": 11, "upper": 11, "bound": 11, "install_requir": [11, 12], "warrant": 11, "wish": [11, 13, 17], "reject": 11, "sphinx": [11, 15], "p0": 11, "gentoo": [11, 13], "30975": 11, "silenc": 11, "deprecationwarn": 11, "legacyvers": 11, "mere": [11, 12], "downstream": [11, 13], "invit": 11, "refin": 11, "experi": [11, 13], "adjust": [11, 13], "guard": 11, "33520": 11, "pattern": [11, 12, 16], "contact": 11, "captur": 11, "kept": 11, "eclib": [11, 13], "ntl": [11, 12], "flint": [11, 12, 13], "configpars": 11, "weaker": 11, "fact": [11, 12, 13], "dependencies_order_onli": 11, "rebuilt": [11, 13, 17], "dependencies_check": 11, "dependencies_opt": 11, "distclean": [11, 13, 17], "polytopes_db_4d": 11, "gb": [11, 13], "integr": [11, 12, 13, 14, 15], "filter": 11, "sage_venv": [11, 12, 13], "sage_doc": 11, "overridden": 11, "hunk": 11, "autodoc_builtin_argspec": 11, "dru": 11, "autodoc": 11, "orig": [11, 16], "2014": 11, "000000000": 11, "1300": 11, "1452": 11, "1462": 11, "app": 11, "add_config_valu": 11, "autoclass_cont": 11, "autodoc_member_ord": 11, "alphabet": 11, "autodoc_default_flag": 11, "autodoc_docstring_signatur": 11, "add_ev": 11, "condition": 11, "solari": 11, "unam": [11, 13], "suno": 11, "unpatch": 11, "handwritten": 11, "bindir": 11, "incdir": 11, "bother": 11, "facil": 11, "automak": 11, "libtool": 11, "portabl": [11, 16], "ac": [11, 13], "autotool": [11, 13], "sage_package_vers": 11, "rf": [11, 12], "mkdir": [11, 13], "sage_package_oldvers": 11, "sage_package_newvers": 11, "database_stein_watkin": 11, "20110713": 11, "vanilla": 11, "p1": [11, 13], "substr": 11, "recomput": 11, "upstream_url": 11, "hold": 11, "archiv": [11, 13], "tpstream_url": 11, "substitut": 11, "numpi": 11, "bz2": 11, "fall": [11, 14], "trim": 11, "mirror_list": 11, "fewer": 11, "scikit_spati": 11, "queri": 11, "watch": 11, "dep": 11, "reinstal": 11, "categori": [11, 12, 14], "scipoptsuit": 11, "academ": 11, "proprietari": 11, "custom": [11, 13], "giac": 11, "criteria": 11, "justifi": 11, "absenc": 11, "leak": 11, "previous": [11, 13, 17], "refere": [11, 14], "hierarch": 12, "fill": 12, "code_bound": 12, "dash": 12, "infrastructur": 12, "ownership": 12, "423": 12, "fallen": 12, "favor": 12, "mainli": 12, "pac": 12, "kage": 12, "distri": 12, "bution": 12, "subset": [12, 13], "mostli": [12, 15], "sws2rst": 12, "sage_sws2rst": 12, "ecosystem": 12, "pplpy": 12, "ppl": 12, "wider": 12, "alloc": 12, "memory_alloc": 12, "420": 12, "tdlib": 12, "graph_decomposit": 12, "rw": [12, 13], "rankwidth": 12, "cycl": [12, 14], "monorepo": 12, "monolith": 12, "manifest": 12, "pyproject": 12, "toml": 12, "hotfix": 12, "suffix": [12, 13], "post1": 12, "post2": 12, "beta8": 12, "anticip": 12, "dev1": 12, "dev2": 12, "development": 12, "beta9": [12, 13], "beta0": 12, "techniqu": 12, "effort": 12, "scene": 12, "vscode": [12, 16], "portion": 12, "phase": [12, 13], "cimport": 12, "pxd": 12, "setup_requir": 12, "partit": 12, "29864": 12, "simultan": 12, "smaller": [12, 13], "audit": 12, "fiximport": 12, "overhead": 12, "inner": 12, "demand": 12, "anti": [12, 16], "isinst": 12, "padicfield": 12, "is_padicfield": 12, "abc": 12, "light": 12, "subclass": 12, "padic": 12, "generic_nod": 12, "padicfieldgener": 12, "incur": 12, "penalti": 12, "qp": 12, "timeit": 12, "68": [12, 13], "success": [12, 13], "cost": 12, "szz": 12, "is_scheme_or_pluff": 12, "xxxx_does_not_exist": 12, "pluff": 12, "143": 12, "\u00b5": 12, "simplifi": [12, 13], "__instancecheck__": 12, "636": 12, "654": 12, "idiom": 12, "arbitrarili": 12, "nest": 12, "beta6": 12, "calculu": 12, "ceil": 12, "grs_code": 12, "guruswami_sudan": 12, "floor": 12, "appar": [12, 14], "substanti": 12, "artithmet": 12, "integer_floor": 12, "integer_ceil": 12, "textual": 12, "heurist": 12, "entropi": 12, "expert": 12, "strong": 12, "ecl": 12, "extras_requir": 12, "limit": [12, 13, 16], "affect": [12, 14], "nicknam": 12, "strength": 12, "mild": 12, "presenc": 12, "solid": 12, "diagram": 12, "sage_conf": 12, "package_dir": 12, "upon": [12, 18], "ipython": 12, "testabl": [12, 14], "number_field": 12, "real_doubl": 12, "symbolicr": 12, "hide": 12, "impli": 12, "clearer": 12, "mainten": 12, "burden": 12, "babel": 12, "py2": 12, "py3": 12, "cp39": 12, "macosx_11_0_x86_64": 12, "jinja2": 12, "5b6": 12, "widgetsnbextens": 12, "zipp": 12, "conf": 12, "dispos": 12, "sage_num_thread": 12, "sagepython": 12, "sagewheel": 12, "nopypi": 12, "32601": 12, "intend": [12, 13], "29865": 12, "valuabl": 12, "regress": 12, "higher": 12, "varieti": [13, 14], "consider": [13, 17], "variat": 13, "spectrum": 13, "announc": [13, 14], "respond": 13, "virtual": [13, 16, 19], "client": 13, "mac": [13, 17], "box": 13, "cloud": 13, "servic": [13, 19], "desktop": [13, 18, 19], "hub": 13, "lt": 13, "mkoepp": [13, 16], "9f3398da43c2": 13, "xenial": 13, "76": 13, "linuxkit": 13, "smp": 13, "oct": 13, "utc": 13, "2019": 13, "df": 13, "mount": 13, "overlai": 13, "181g": 13, "116g": 13, "56g": 13, "tmpf": 13, "64m": 13, "dev": 13, "7g": 13, "cgroup": 13, "shm": 13, "sda1": 13, "proc": 13, "acpi": 13, "firmwar": 13, "lose": 13, "preciou": 13, "miss": [13, 14, 16], "bind": 13, "39d693b2a75d": 13, "osxf": 13, "fuse": 13, "nosuid": 13, "nodev": 13, "relatim": 13, "user_id": 13, "group_id": 13, "allow_oth": 13, "max_read": 13, "1048576": 13, "gcc": 13, "guess": 13, "hope": 13, "forgot": 13, "remind": 13, "rememb": 13, "_prereq": 13, "binutil": 13, "perl": 13, "buster": 13, "bionic": 13, "urllib": 13, "bc": 13, "surviv": 13, "preprocessor": 13, "cpp": 13, "ca": [13, 14, 16], "newest": 13, "29b": 13, "2ubuntu0": 13, "unprivileg": 13, "arb": 13, "boost_crop": 13, "bzip2": 13, "zeromq": 13, "zlib": 13, "libflint": 13, "libzmq3": 13, "libz": 13, "recheck": 13, "libbz2": 13, "zlib1g": 13, "amd64": 13, "dfsg": 13, "0ubuntu2": 13, "n3": 13, "sha256": 13, "4151c5ca4476660f6181cdb13923da8fe44082222b984c377fb4fd6cc05415c1": 13, "73987568712c": 13, "bunzip2": 13, "quick": 13, "base_imag": 13, "debian_frontend": 13, "noninteract": 13, "qqq": 13, "workdir": 13, "md": [13, 17, 18], "extra_configure_arg": 13, "numproc": 13, "j": 13, "use_makeflag": 13, "toolchain": 13, "targets_pr": 13, "ratpoint": 13, "daemon": 13, "285mb": 13, "549b9b86cb8d": 13, "logger": 13, "p5": 13, "0m18": 13, "886": 13, "0m1": 13, "779": 13, "0m0": 13, "314": 13, "2d06689d39fa": 13, "fab59e09a641": 13, "236": 13, "231169": 13, "mar": 13, "6025": 13, "rat": 13, "177256": 13, "libratpoint": 13, "elsewher": 13, "contrast": 13, "exclus": [13, 16], "gitignor": 13, "dockerignor": 13, "artefact": 13, "suspect": 13, "surf": 13, "2017": 13, "17d0ddb5ad7b": 13, "7b51411520c3": 13, "61833bea6a6d": 13, "j4": [13, 17], "gcc6": 13, "mit": 13, "edu": 13, "ld": 13, "lfl": 13, "collect2": 13, "504": 13, "2088": 13, "remad": 13, "cp": 13, "acinclud": 13, "acloc": 13, "dither": 13, "mkinstalldir": 13, "pic": 13, "mt": 13, "draw": 13, "drawfunc": 13, "xpm": 13, "sub": 13, "gtkgui": 13, "yaccsrc": 13, "earlier": 13, "003fbd511016fe305bd8494bb1747f0fbf4cb2c788b4e755e9099d9f2014a60d": 13, "003fbd511": 13, "2d9ac65f4572": 13, "buildsh": 13, "subshel": 13, "libfl": 13, "flex": 13, "freebsd": 13, "buildutil": 13, "sane": 13, "644": 13, "man": 13, "man1": 13, "bitrot": 13, "archlinux": 13, "slackwar": 13, "cento": 13, "i386": 13, "arm64": 13, "_bootstrap": 13, "suppli": 13, "extra_docker_build_arg": 13, "431": 13, "gca4b5b2f33": 13, "dirti": 13, "docker_target": 13, "109": 13, "echo": 13, "4bb14c3d5646": 13, "g861ba33bbc": 13, "egret": 13, "spring": 13, "7ecfa86fceab": 13, "4314929e2b4c": 13, "straightforward": 13, "variant": 13, "fresh": [13, 14], "pythonhashse": [13, 16], "2211987514": 13, "rpath": 13, "328": 13, "succeed": [13, 16], "congratul": [13, 16], "investig": 13, "la": 13, "2576": 13, "drwxr": 13, "xr": 13, "staff": 13, "1120": 13, "63": 13, "lrwxr": 13, "74": 13, "1212": 13, "224": 13, "7542": 13, "rwxr": 13, "90411": 13, "887180": 13, "17070": 13, "768": 13, "105": 13, "4868": 13, "13478": 13, "165968": 13, "sbin": 13, "sfw": 13, "lrslib": 13, "4246149402": 13, "tap": 13, "4942": 13, "205": 13, "310": 13, "7mb": 13, "ftp": 13, "gettext": 13, "xz": 13, "pour": 13, "autoconf": 13, "catalina": 13, "bottl": 13, "cellar": 13, "623": 13, "4kb": 13, "caveat": [13, 14], "keg": 13, "symlink": 13, "bash_profil": 13, "ldflag": 13, "cppflag": 13, "cbc": 13, "cliquer": 13, "tachyon": 13, "gsl": 13, "mpfi": 13, "ninja": 13, "openbla": 13, "gpatch": 13, "readlin": 13, "062": 13, "python3_xcod": 13, "python3_pythonorg": 13, "themselv": 13, "forg": [13, 17], "miniconda": 13, "anaconda": 13, "channel": 13, "skip_system_pkg_instal": 13, "skip_bootstrap": 13, "skip_configur": 13, "multitud": 13, "yml": [13, 16], "ssd": 13, "cf": 13, "6h": 13, "bare": 13, "plenti": [13, 15], "artifact": 13, "lightweight": 13, "overwrit": 13, "tester": 13, "green": 13, "checkmark": 13, "reflect": [13, 18], "scroll": 13, "red": 13, "8ca1c2df8f1fb4c6d54b44b34b4d8320ebecb164": 13, "sagetex": 13, "IN": 13, "cddlib": 13, "ecm": 13, "fplll": 13, "givaro": 13, "viewer": 13, "password": 13, "checkbox": 13, "button": 13, "de1ec7ab1ec0ffee5ca1dedbaff1ed0ddba11": 13, "f4bd671": 13, "d5fd17ec1767": 13, "67586203f0c7": 13, "b63c529f4777": 13, "159775d1a3d2": 13, "digest": 13, "e6ba5e12f59c6c4668692ef4cfe4ae5f242556482664fb347bf260f32bf8e698": 13, "8055a7ba0607": 13, "2022": 13, "studio": 13, "icon": 13, "shift": 13, "devcontain": 13, "sampl": 13, "palett": 13, "reopen": [13, 14], "jammi": 13, "gigabyt": 13, "oncreatecommand": 13, "updatecontentcommand": 13, "computop": 13, "manifold": [13, 16], "snappi": 13, "regina": 13, "phcpack": 13, "_sagemath": 13, "cocalc": 13, "deploy": 13, "ey": 14, "spot": 14, "insuffici": 14, "aim": 14, "robust": 14, "unexpect": 14, "she": 14, "suffici": 14, "wonder": 14, "bugfix": 14, "badli": 14, "unrel": 14, "feel": [14, 17], "mercuri": 14, "enemi": 14, "prematur": 14, "laundri": 14, "remain": 14, "limbo": 14, "bomb": 14, "000": 14, "bundl": 14, "rip": 14, "subsystem": 14, "imagin": 14, "tediou": 14, "gradual": 14, "philosophi": 14, "combinatori": 14, "explos": 14, "ten": 14, "commonli": [14, 17, 18], "tracker": 14, "willing": 14, "hopefulli": 14, "tri": 14, "couldn": 14, "afoul": 14, "candid": 14, "forthcom": 14, "mileston": [14, 17], "batch": 14, "undergo": 14, "unmerg": 14, "merit": 14, "high": [14, 17, 19], "benefit": [14, 19], "trade": 14, "unforeseen": 14, "rational": 14, "docbuild": 15, "toward": [15, 16, 17], "module_nam": 15, "mod1": 15, "mod2": 15, "mod3": 15, "method_on": 15, "method_two": 15, "role": 15, "17596": 15, "sage_": 15, "mathematics_softwar": 15, "arxiv": 15, "1202": 15, "1506": 15, "encyclopedia": 15, "sequenc": 15, "a000081": 15, "2752": 15, "175303708x390473": 15, "mathscinet": 15, "mr0100971": 15, "anonym": 15, "twice": [15, 17], "__": 15, "example2": 15, "matroid": 15, "my_algorithm": 15, "module_list": 15, "sage_docbuild": 15, "thin": 15, "quickstart": 15, "builder": 15, "lang": 15, "english": 15, "french": 15, "preced": 15, "descrobject": 15, "ctypedef": 15, "struct": 15, "pymethoddef": 15, "void": 15, "ml_meth": 15, "pymethoddescrobject": 15, "d_method": 15, "pycfunction_get_funct": 15, "bint": 15, "pycfunction_check": 15, "envlist": 16, "forbidden": 16, "patchbot": 16, "plugin": 16, "markup": 16, "misspel": 16, "checker": 16, "coverageal": 16, "conform": 16, "28778046": 16, "e401": 16, "e70": 16, "w605": 16, "e711": 16, "e712": 16, "e721": 16, "___________": 16, "____________": 16, "turnaround": 16, "thorough": 16, "quadratic_form": 16, "2520226550": 16, "e225": 16, "165": 16, "173": 16, "e228": 16, "1620": 16, "e266": 16, "1621": 16, "e111": 16, "e117": 16, "129": 16, "e127": 16, "e128": 16, "e201": 16, "e202": 16, "e222": 16, "e231": 16, "e262": 16, "inlin": 16, "e265": 16, "e272": 16, "e301": 16, "e303": 16, "invocationerror": 16, "cleanup": 16, "complianc": 16, "harder": 16, "3166223974": 16, "557": 16, "e112": 16, "194": 16, "e114": 16, "e743": 16, "335": 16, "w291": 16, "w292": 16, "newlin": 16, "229": 16, "w293": 16, "459": 16, "w391": 16, "97797": 16, "pycodestyleen": 16, "sync": 16, "pycqa": 16, "outdat": 16, "mistak": 16, "dictionari": 16, "homologi": 16, "1285169064": 16, "jpg": 16, "dia": 16, "ico": 16, "bak": 16, "sobj": 16, "pyc": 16, "sw": 16, "ds_store": 16, "hu": 16, "ja": 16, "ru": 16, "tr": 16, "autom4t": 16, "hochschild_complex": 16, "271": 16, "mone": 16, "mono": 16, "monei": 16, "277": 16, "280": 16, "chain_complex": 16, "2185": 16, "mor": 16, "2204": 16, "2210": 16, "2211": 16, "2214": 16, "2215": 16, "65": 16, "testenv": 16, "backend": 16, "pytest_xdist": 16, "test_fil": 16, "across": 16, "spawn": 16, "worker": 16, "offic": 16, "conftest": 16, "npm": 16, "pylanc": 16, "pyrightconfig": 16, "microsoft": 16, "gpg": 17, "subcommand": 17, "giant": 17, "capit": 17, "bewar": 17, "asterisk": 17, "last_twin_prim": 17, "topmost": 17, "dig": 17, "deeper": 17, "revers": 17, "tig": 17, "some_fil": 17, "untrack": 17, "last_pair": 17, "restart": 17, "believ": 17, "recython": 17, "subsequ": 17, "ccach": 17, "unlik": 17, "unstag": 17, "31331f7": 17, "foobar": 17, "twin": [17, 18], "iter": 18, "approv": 18, "pull_request_templ": 18, "50": 18, "83": 18, "98": 18, "352d842907": 18, "56ffdab967": 18, "happi": 18, "cleanli": 18, "smart": 18, "30500": 19, "gitlab": 19, "tempkei": 19, "private_ssh_kei": 19, "ui": 19, "regist": 19, "spec": 19, "prebuild": 19}, "objects": {}, "objtypes": {}, "objnames": {}, "titleterms": {"gener": [0, 7, 13], "convent": 0, "python": [0, 3, 11], "code": [0, 1, 3, 10, 11, 13, 14, 15, 17], "style": 0, "file": [0, 1, 4, 11, 15], "directori": [0, 11, 12], "structur": [0, 11], "learn": 0, "copi": 0, "past": 0, "head": [0, 5], "sage": [0, 1, 3, 4, 5, 9, 10, 11, 12, 13, 15, 17, 19], "librari": [0, 2, 4, 12], "document": [0, 10, 15], "string": 0, "The": [0, 2, 3, 9, 11, 14, 15, 17], "docstr": 0, "function": [0, 3, 11], "content": [0, 10], "note": [0, 9], "about": 0, "sphinx": 0, "direct": [0, 13], "v": [0, 12, 13], "other": [0, 5, 12], "block": 0, "": [0, 4, 13], "master": 0, "bibliographi": 0, "templat": 0, "fine": 0, "point": 0, "privat": 0, "latex": [0, 3], "typeset": 0, "write": [0, 1, 10], "testabl": 0, "exampl": 0, "special": [0, 3], "markup": 0, "influenc": 0, "doctest": [0, 4, 12, 16], "run": [0, 4], "autom": 0, "test": [0, 4, 10, 11, 12, 13, 16], "py": 0, "pyx": 0, "rest": 0, "regard": 0, "whitespac": 0, "global": 0, "option": [0, 3, 4, 13], "miscellan": [0, 4], "minor": 0, "thing": 0, "cython": [1, 15, 16], "attach": 1, "load": 1, "spyx": 1, "interrupt": 1, "signal": 1, "handl": 1, "unpickl": 1, "us": [2, 3, 4, 9, 11, 13, 18, 19], "extern": [2, 4], "interfac": 2, "pari": 2, "c": 2, "gap": 2, "libgap": 2, "singular": 2, "anoth": 2, "approach": 2, "creat": [2, 9, 11, 18], "new": [2, 11, 15, 18], "pseudo": 2, "tty": 2, "languag": 3, "standard": [3, 11], "design": 3, "represent": 3, "print": 3, "matrix": 3, "vector": 3, "from": [3, 4, 7], "object": 3, "prepars": 3, "coercion": 3, "model": 3, "mutabl": 3, "__hash__": 3, "method": 3, "except": 3, "integ": 3, "return": 3, "valu": 3, "import": 3, "deprec": 3, "experiment": 3, "unstabl": 3, "packag": [3, 10, 11, 12, 13], "modul": [4, 12], "troubleshoot": 4, "parallel": 4, "mani": 4, "whole": 4, "beyond": 4, "within": 4, "argument": 4, "long": 4, "all": 4, "debug": [4, 13], "tool": [4, 7, 16], "show": 4, "onli": [4, 12], "first": [4, 10], "failur": 4, "skip": 4, "iter": 4, "differ": [4, 13], "timeout": 4, "absolut": 4, "path": 4, "chang": [4, 7, 18], "random": 4, "order": 4, "auxiliari": 4, "advanc": [5, 6], "git": [5, 6, 7, 8, 9, 10, 17, 18], "detach": 5, "review": [5, 14], "pr": [5, 7, 9, 14, 18], "updat": [5, 7, 10, 11], "branch": [5, 17, 18], "latest": 5, "version": [5, 11, 12], "introduct": 5, "merg": [5, 6, 7, 18], "minim": 5, "recompil": 5, "time": [5, 12], "why": 5, "wai": 5, "round": 5, "reset": 5, "recoveri": 5, "rewrit": 5, "histori": [5, 17], "interact": 5, "rebas": [5, 7], "tip": 6, "refer": 6, "configur": [6, 8, 9], "alias": 6, "editor": [6, 19], "fanci": 6, "log": 6, "output": 6, "tutori": 6, "summari": 6, "beginn": 6, "best": [6, 13], "practic": 6, "manual": [6, 15], "page": 6, "onlin": 6, "basic": 7, "authent": 7, "through": [7, 17], "ssh": 7, "your": [7, 9, 19], "kei": 7, "ad": [7, 15], "public": 7, "github": [7, 9, 10, 13, 18], "push": 7, "remot": 7, "check": [7, 9, 17, 18], "out": [7, 17, 18], "get": 7, "develop": [7, 10, 13, 16, 17, 18], "conflict": 7, "resolut": 7, "set": [8, 11, 19], "up": [8, 18, 19], "instal": [8, 9, 11, 13], "repositori": 9, "obtain": [9, 17], "account": 9, "cli": 9, "link": 9, "fork": 9, "report": 9, "bug": [9, 13], "plan": 9, "an": [9, 18], "enhanc": 9, "open": 9, "issu": 9, "pull": 9, "request": 9, "statu": 9, "stopgap": 9, "comment": 9, "final": 9, "welcom": 10, "guid": 10, "tabl": 10, "step": 10, "work": 10, "more": [10, 18], "indic": 10, "third": 11, "parti": 11, "type": 11, "sourc": [11, 12, 17], "build": [11, 12, 13, 15], "script": 11, "normal": 11, "helper": 11, "allow": 11, "system": [11, 13], "self": 11, "base": [11, 13], "spkg": 11, "rst": 11, "depend": [11, 12], "tag": 11, "where": 11, "ar": 11, "patch": 11, "when": 11, "repackag": 11, "autoconfisc": 11, "how": 11, "maintain": 11, "modifi": 11, "tarbal": 11, "checksum": 11, "name": [11, 15], "upstream": [11, 18], "url": 11, "util": 11, "inclus": 11, "procedur": 11, "licens": 11, "inform": 11, "prerequisit": [11, 13], "distribut": [12, 13], "ordinari": 12, "implicit": 12, "namespac": 12, "level": 12, "runtim": 12, "constraint": 12, "hierarchi": 12, "prepar": 12, "virtual": 12, "environ": 12, "tox": [12, 13, 16], "multipl": 13, "platform": 13, "action": 13, "buildbot": 13, "user": 13, "releas": [13, 14], "docker": 13, "discov": 13, "databas": 13, "equival": 13, "commit": [13, 17], "contain": 13, "disk": 13, "dockerfil": 13, "portabl": 13, "automat": 13, "host": 13, "o": 13, "e": 13, "local": 13, "effort": 13, "isol": 13, "maco": 13, "homebrew": 13, "conda": 13, "technologi": 13, "our": 13, "pre": 13, "built": 13, "imag": 13, "publish": 13, "ghcr": 13, "io": 13, "close": 14, "reason": 14, "invalid": 14, "process": 14, "edit": [15, 17], "hyperlink": 15, "syntax": 15, "highlight": 15, "addit": 16, "coverag": 16, "startuptim": 16, "pycodestyl": 16, "lint": 16, "relint": 16, "codespel": 16, "pytest": 16, "pyright": 16, "pyflak": 16, "walk": 17, "rebuild": 17, "make": 17, "workflow": 18, "glanc": 18, "exist": 18, "upload": 18, "finish": 18, "workspac": 19, "text": 19, "id": 19, "gitpod": 19}, "envversion": {"sphinx.domains.c": 2, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 8, "sphinx.domains.index": 1, "sphinx.domains.javascript": 2, "sphinx.domains.math": 2, "sphinx.domains.python": 3, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx.ext.todo": 2, "sphinx": 57}, "alltitles": {"General Conventions": [[0, "general-conventions"]], "Python code style": [[0, "python-code-style"]], "Files and directory structure": [[0, "files-and-directory-structure"]], "Learn by copy/paste": [[0, "learn-by-copy-paste"]], "Headings of Sage library code files": [[0, "headings-of-sage-library-code-files"]], "Documentation strings": [[0, "documentation-strings"]], "The docstring of a function: content": [[0, "the-docstring-of-a-function-content"]], "Note about Sphinx directives vs. other blocks": [[0, "note-about-sphinx-directives-vs-other-blocks"]], "Sage documentation style": [[0, "sage-documentation-style"]], "Sage\u2019s master BIBLIOGRAPHY file": [[0, "sage-s-master-bibliography-file"]], "Template": [[0, "template"]], "Fine points on styles": [[0, "fine-points-on-styles"]], "Private functions": [[0, "private-functions"]], "LaTeX typesetting": [[0, "latex-typesetting"]], "Writing testable examples": [[0, "writing-testable-examples"]], "Special markup to influence doctests": [[0, "special-markup-to-influence-doctests"]], "Running automated doctests": [[0, "running-automated-doctests"]], "Testing .py, .pyx and .sage files": [[0, "testing-py-pyx-and-sage-files"]], "Testing reST documentation": [[0, "testing-rest-documentation"]], "General coding style regarding whitespace": [[0, "general-coding-style-regarding-whitespace"]], "Global options": [[0, "global-options"]], "Miscellaneous minor things": [[0, "miscellaneous-minor-things"]], "Coding in Cython": [[1, "coding-in-cython"]], "Writing cython code in Sage": [[1, "writing-cython-code-in-sage"]], "Attaching or loading .spyx files": [[1, "attaching-or-loading-spyx-files"]], "Interrupt and signal handling": [[1, "interrupt-and-signal-handling"]], "Unpickling Cython code": [[1, "unpickling-cython-code"]], "Using External Libraries and Interfaces": [[2, "using-external-libraries-and-interfaces"]], "The PARI C library interface": [[2, "the-pari-c-library-interface"]], "GAP": [[2, "gap"]], "LibGAP": [[2, "libgap"]], "Singular": [[2, "singular"]], "Singular: another approach": [[2, "singular-another-approach"]], "Creating a new pseudo-TTY interface": [[2, "creating-a-new-pseudo-tty-interface"]], "Coding in Python for Sage": [[3, "coding-in-python-for-sage"]], "Python language standard": [[3, "python-language-standard"]], "Design": [[3, "design"]], "Special sage functions": [[3, "special-sage-functions"]], "LaTeX Representation": [[3, "latex-representation"]], "Print representation": [[3, "print-representation"]], "Matrix or vector from object": [[3, "matrix-or-vector-from-object"]], "Sage preparsing": [[3, "sage-preparsing"]], "The Sage coercion model": [[3, "the-sage-coercion-model"]], "Mutability": [[3, "mutability"]], "The  __hash__ special method": [[3, "the-hash-special-method"]], "Exceptions": [[3, "exceptions"]], "Integer return values": [[3, "integer-return-values"]], "Importing": [[3, "importing"]], "Deprecation": [[3, "deprecation"]], "Experimental/unstable code": [[3, "experimental-unstable-code"]], "Using optional packages": [[3, "using-optional-packages"]], "Running Sage\u2019s Doctests": [[4, "running-sage-s-doctests"]], "Testing a module": [[4, "testing-a-module"]], "Troubleshooting": [[4, "troubleshooting"]], "Parallel testing many modules": [[4, "parallel-testing-many-modules"]], "Parallel testing the whole Sage library": [[4, "parallel-testing-the-whole-sage-library"]], "Beyond the Sage library": [[4, "beyond-the-sage-library"]], "Doctesting from within Sage": [[4, "doctesting-from-within-sage"]], "Optional arguments": [[4, "optional-arguments"]], "Run long doctests": [[4, "run-long-doctests"]], "Run optional doctests": [[4, "run-optional-doctests"]], "Running doctests in parallel": [[4, "running-doctests-in-parallel"]], "Doctesting all of Sage": [[4, "doctesting-all-of-sage"]], "Debugging tools": [[4, "debugging-tools"]], "Miscellaneous options": [[4, "miscellaneous-options"]], "Show only first failure": [[4, "show-only-first-failure"]], "Show skipped optional tests": [[4, "show-skipped-optional-tests"]], "Running tests with iterations": [[4, "running-tests-with-iterations"]], "Using a different timeout": [[4, "using-a-different-timeout"]], "Using absolute paths": [[4, "using-absolute-paths"]], "Testing changed files": [[4, "testing-changed-files"]], "Running tests in a random order": [[4, "running-tests-in-a-random-order"]], "Testing external files": [[4, "testing-external-files"]], "Auxiliary files": [[4, "auxiliary-files"]], "Advanced Git": [[5, "advanced-git"]], "Detached heads and reviewing PRs": [[5, "detached-heads-and-reviewing-prs"]], "Update branch to latest Sage version": [[5, "update-branch-to-latest-sage-version"]], "Introduction": [[5, "introduction"]], "Merge in the latest Sage version": [[5, "merge-in-the-latest-sage-version"]], "Minimize the recompilation time": [[5, "minimize-the-recompilation-time"]], "Why not merging the other way round?": [[5, "why-not-merging-the-other-way-round"]], "Reset and recovery": [[5, "reset-and-recovery"]], "Rewriting history": [[5, "rewriting-history"]], "Interactively rebasing": [[5, "interactively-rebasing"]], "Git Tips and References": [[6, "git-tips-and-references"]], "Configuration tips": [[6, "configuration-tips"]], "Aliases": [[6, "aliases"]], "Editor": [[6, "editor"]], "Merging": [[6, "merging"]], "Fancy log output": [[6, "fancy-log-output"]], "Tutorials and summaries": [[6, "tutorials-and-summaries"]], "Beginner": [[6, "beginner"]], "Advanced": [[6, "advanced"]], "Git best practices": [[6, "git-best-practices"]], "Manual pages online": [[6, "manual-pages-online"]], "Git Basics": [[7, "git-basics"]], "Git authentication through SSH": [[7, "git-authentication-through-ssh"]], "Generating your SSH keys": [[7, "generating-your-ssh-keys"]], "Adding your public key for authentication to GitHub": [[7, "adding-your-public-key-for-authentication-to-github"]], "Pushing your changes to a remote": [[7, "pushing-your-changes-to-a-remote"]], "Checking out a PR": [[7, "checking-out-a-pr"]], "Getting changes from a remote": [[7, "getting-changes-from-a-remote"]], "Updating develop": [[7, "updating-develop"]], "Merging and rebasing": [[7, "merging-and-rebasing"]], "Merge tools": [[7, "merge-tools"]], "Conflict resolution": [[7, "conflict-resolution"]], "Setting Up Git": [[8, "setting-up-git"]], "Installing Git": [[8, "installing-git"]], "Configuring Git": [[8, "configuring-git"]], "The Sage Repository on GitHub": [[9, "the-sage-repository-on-github"]], "Obtaining a GitHub account": [[9, "obtaining-a-github-account"]], "Using the GitHub CLI": [[9, "using-the-github-cli"]], "Installation": [[9, "installation"]], "Configuration": [[9, "configuration"]], "Linking Git to your GitHub account": [[9, "linking-git-to-your-github-account"]], "Forking the Sage repository": [[9, "forking-the-sage-repository"]], "Reporting bugs": [[9, "reporting-bugs"]], "Planning an enhancement": [[9, "planning-an-enhancement"]], "Opening an issue": [[9, "opening-an-issue"]], "Creating a Pull Request": [[9, "creating-a-pull-request"]], "The status of a PR": [[9, "the-status-of-a-pr"]], "The stopgap": [[9, "the-stopgap"]], "Commenting issues and PRs": [[9, "commenting-issues-and-prs"]], "Checks on PRs": [[9, "checks-on-prs"]], "Final notes": [[9, "final-notes"]], "Welcome to Sage Developer Guide": [[10, "welcome-to-sage-developer-guide"]], "Table of Contents": [[10, "table-of-contents"]], "First Steps": [[10, "first-steps"]], "Working on GitHub": [[10, "working-on-github"]], "Working with Git": [[10, "working-with-git"]], "Writing Code for Sage": [[10, "writing-code-for-sage"]], "Testing Sage": [[10, "testing-sage"]], "Updating Sage Documentation": [[10, "updating-sage-documentation"]], "More on Coding for Sage": [[10, "more-on-coding-for-sage"]], "Packaging": [[10, "packaging"]], "Indices and tables": [[10, "indices-and-tables"]], "Packaging Third-Party Code for Sage": [[11, "packaging-third-party-code-for-sage"]], "Package types": [[11, "package-types"]], "Package source types": [[11, "package-source-types"]], "Directory structure": [[11, "directory-structure"]], "Package type": [[11, "package-type"]], "Build and install scripts of normal packages": [[11, "build-and-install-scripts-of-normal-packages"]], "Install scripts of script packages": [[11, "install-scripts-of-script-packages"]], "Helper functions": [[11, "helper-functions"]], "Allowing for the use of system packages": [[11, "allowing-for-the-use-of-system-packages"]], "Self-tests": [[11, "self-tests"]], "Python-based packages": [[11, "python-based-packages"]], "The SPKG.rst file": [[11, "the-spkg-rst-file"]], "Package dependencies": [[11, "package-dependencies"]], "Package tags": [[11, "package-tags"]], "Where packages are installed": [[11, "where-packages-are-installed"]], "Patching sources": [[11, "patching-sources"]], "When to patch, when to repackage, when to autoconfiscate": [[11, "when-to-patch-when-to-repackage-when-to-autoconfiscate"]], "How to maintain a set of patches": [[11, "how-to-maintain-a-set-of-patches"]], "Modified tarballs": [[11, "modified-tarballs"]], "Package versioning": [[11, "package-versioning"]], "Checksums and tarball names": [[11, "checksums-and-tarball-names"]], "Upstream URLs": [[11, "upstream-urls"]], "Utility script to create packages": [[11, "utility-script-to-create-packages"]], "Building the package": [[11, "building-the-package"]], "Inclusion procedure for new and updated packages": [[11, "inclusion-procedure-for-new-and-updated-packages"]], "License information": [[11, "license-information"]], "Prerequisites for new standard packages": [[11, "prerequisites-for-new-standard-packages"]], "Packaging the Sage Library for Distribution": [[12, "packaging-the-sage-library-for-distribution"]], "Modules, packages, distribution packages": [[12, "modules-packages-distribution-packages"]], "Ordinary packages vs. implicit namespace packages": [[12, "ordinary-packages-vs-implicit-namespace-packages"]], "Source directories of distribution packages": [[12, "source-directories-of-distribution-packages"]], "Dependencies and distribution packages": [[12, "dependencies-and-distribution-packages"]], "Build-time dependencies": [[12, "build-time-dependencies"]], "Module-level runtime dependencies": [[12, "module-level-runtime-dependencies"]], "Other runtime dependencies": [[12, "other-runtime-dependencies"]], "Doctest-only dependencies": [[12, "doctest-only-dependencies"]], "Version constraints of dependencies": [[12, "version-constraints-of-dependencies"]], "Hierarchy of distribution packages": [[12, "hierarchy-of-distribution-packages"]], "Testing distribution packages": [[12, "testing-distribution-packages"]], "Preparing doctests": [[12, "preparing-doctests"]], "Testing the distribution in virtual environments with tox": [[12, "testing-the-distribution-in-virtual-environments-with-tox"]], "Testing on Multiple Platforms": [[13, "testing-on-multiple-platforms"]], "GitHub actions": [[13, "github-actions"]], "Sage buildbots": [[13, "sage-buildbots"]], "Developers\u2019 and users\u2019 tests on sage-release": [[13, "developers-and-users-tests-on-sage-release"]], "Testing Sage on a different platform using Docker": [[13, "testing-sage-on-a-different-platform-using-docker"]], "Discovering the system\u2019s package system": [[13, "discovering-the-system-s-package-system"]], "Using Sage\u2019s database of distribution prerequisites": [[13, "using-sage-s-database-of-distribution-prerequisites"]], "Using Sage\u2019s database of equivalent distribution packages": [[13, "using-sage-s-database-of-equivalent-distribution-packages"]], "Committing a container to disk": [[13, "committing-a-container-to-disk"]], "Generating dockerfiles": [[13, "generating-dockerfiles"]], "Debugging a portability bug using Docker": [[13, "debugging-a-portability-bug-using-docker"]], "Automatic Docker-based build testing using tox": [[13, "automatic-docker-based-build-testing-using-tox"]], "Automatic build testing on the host OS using tox -e local-direct": [[13, "automatic-build-testing-on-the-host-os-using-tox-e-local-direct"]], "Automatic build testing on the host OS with best-effort isolation using tox -e local": [[13, "automatic-build-testing-on-the-host-os-with-best-effort-isolation-using-tox-e-local"]], "Automatic build testing on macOS with a best-effort isolated installation of Homebrew": [[13, "automatic-build-testing-on-macos-with-a-best-effort-isolated-installation-of-homebrew"]], "Automatic build testing with a best-effort isolated installation of Conda": [[13, "automatic-build-testing-with-a-best-effort-isolated-installation-of-conda"]], "Options for build testing with the local technology": [[13, "options-for-build-testing-with-the-local-technology"]], "Automatic testing on multiple platforms on GitHub Actions": [[13, "automatic-testing-on-multiple-platforms-on-github-actions"]], "Using our pre-built Docker images published on ghcr.io": [[13, "using-our-pre-built-docker-images-published-on-ghcr-io"]], "Using our pre-built Docker images for development in VS Code": [[13, "using-our-pre-built-docker-images-for-development-in-vs-code"]], "Reviewing Code": [[14, "reviewing-code"]], "Reviewing and closing PRs": [[14, "reviewing-and-closing-prs"]], "Reasons to invalidate PRs": [[14, "reasons-to-invalidate-prs"]], "The release process": [[14, "the-release-process"]], "The Sage Manuals": [[15, "the-sage-manuals"]], "Editing the documentation": [[15, "editing-the-documentation"]], "Hyperlinks": [[15, "hyperlinks"]], "Adding a new file": [[15, "adding-a-new-file"]], "Building the manuals": [[15, "building-the-manuals"]], "Document names": [[15, "document-names"]], "Syntax highlighting Cython code": [[15, "syntax-highlighting-cython-code"]], "Additional Development and Testing Tools": [[16, "additional-development-and-testing-tools"]], "Tox": [[16, "tox"]], "Doctest": [[16, "doctest"]], "Coverage": [[16, "coverage"]], "Startuptime": [[16, "startuptime"]], "Pycodestyle": [[16, "pycodestyle"]], "Cython-lint": [[16, "cython-lint"]], "Relint": [[16, "relint"]], "Codespell": [[16, "codespell"]], "Pytest": [[16, "pytest"]], "Pyright": [[16, "pyright"]], "Pyflakes": [[16, "pyflakes"]], "Development Walk-through": [[17, "development-walk-through"]], "Checking Git": [[17, "checking-git"]], "Obtaining the Sage source code": [[17, "obtaining-the-sage-source-code"]], "Branching out": [[17, "branching-out"]], "The history": [[17, "the-history"]], "Editing the source code": [[17, "editing-the-source-code"]], "Rebuilding Sage": [[17, "rebuilding-sage"]], "Making commits": [[17, "making-commits"]], "Using Git with GitHub": [[18, "using-git-with-github"]], "Development workflow at a glance": [[18, "development-workflow-at-a-glance"]], "Creating a new PR": [[18, "creating-a-new-pr"]], "Checking out an existing PR": [[18, "checking-out-an-existing-pr"]], "Uploading more changes to GitHub": [[18, "uploading-more-changes-to-github"]], "Finishing it up": [[18, "finishing-it-up"]], "Merging the upstream develop branch": [[18, "merging-the-upstream-develop-branch"]], "Setting up your workspace": [[19, "setting-up-your-workspace"]], "Text editors and IDEs for use with Sage": [[19, "text-editors-and-ides-for-use-with-sage"]], "Gitpod": [[19, "gitpod"]]}, "indexentries": {"pep 0008": [[0, "index-0"]], "pep 0257": [[0, "index-1"]], "python enhancement proposals": [[0, "index-0"], [0, "index-1"]], "make": [[4, "index-0"], [4, "index-1"]], "environment variable": [[4, "index-0"], [4, "index-1"], [11, "index-0"], [11, "index-1"], [11, "index-2"], [11, "index-3"], [11, "index-4"], [11, "index-5"], [11, "index-6"], [13, "index-0"], [13, "index-1"], [13, "index-2"], [13, "index-3"], [17, "index-0"]], "cflags": [[11, "index-0"]], "cxxflags": [[11, "index-1"], [11, "index-4"]], "f77flags": [[11, "index-3"], [11, "index-6"]], "fcflags": [[11, "index-2"], [11, "index-5"]], "sage_local": [[13, "index-1"], [13, "index-2"]], "sage_root": [[13, "index-0"], [17, "index-0"]], "sage_venv": [[13, "index-3"]]}})